import mysql from "mysql";
import express from "express";

const connection = mysql.createPool({
  connectionLimit: 10,
  host: "ssica-mysqldb.mysql.database.azure.com",
  port: 3306,
  database: "as400_data",
  user: "BWMMIS1@ssica-mysqldb",
  password: "timetravel",
});


const app = express();
app.use(express.json());
app.use(express.urlencoded({ extended: true }));

const PORT = "8080";

app.listen(PORT, () => {
  console.log(`PORT: ${PORT}`);
  connection.getConnection((err) => {
    if (err) throw err;
    console.log("DATABASE CONNECTED");
  });
});

//-----------------
// GET
//-----------------
app.use("/app001", (req, res) => {
  
  var beg1 = new Date().getTime();

  // Get the SQL Query using either the sequence number or the title
  let rpt = req.query.rpt;
  console.log('-------------------------\nRPT: ' + rpt);

  var sql_query =
    "select sql_stmt from zzz_api_queries where seq = '${rpt}' or title = '${rpt}' ";
  sql_query = sql_query.replace(/\${rpt}/g, rpt);
  console.log("Get Report: " + sql_query);

  connection.query(sql_query, (err, result) => {
    if (err) throw err;
    var len1 = result.length;
    console.log("Records: " + len1);
    if (len1 == 0) {
      res.send([]);
      return;
    }
    console.log("Result: " + result[0].sql_stmt);
    var sql_query = result[0].sql_stmt;

    //  Loop thru 10 allowed input parms and replace the value in the sql statement
    let i = 0;
    for (i = 0; i < 10; i++) {
      let fld = "in" + i;
      let inp = req.query[fld];
      if (inp != undefined) {
        let fld2 = "${" + fld + "}";
        sql_query = sql_query.replace(fld2, inp);
        console.log("INPUT PARM: " + fld + " " + inp + " ");
      }
    }

    console.log("SQL: " + sql_query);

    // Execute the query and return the JSON result
    connection.query(sql_query, (err, result, fields) => {
    //if (err) throw err;
      if (err) { 
         console.log(err.stack); 
         res.send("ERROR"); 
         return ; 
        }
      var len1 = result.length;
      console.log("Records:" + len1);
      res.send(result);

      var end1 = new Date().getTime();
      //console.log('END:' + end1);
      var s = (end1 - beg1); 
      var ms = s % 1000;
      s = (s - ms) / 1000;
      var secs = s % 60;
      s = (s - secs) / 60;
      var mins = s % 60;
      var hrs = (s - mins) / 60;
      var diff =  mins + 'm ' + secs + 's ' + ms + 'ms';
      console.log('-------------------------\nRun Time: ' + diff + '\n-------------------------\n');
    });
  });
});

//-----------------
// POST
//-----------------
app.post("/app002", (req, res) => {
  var beg1 = new Date().getTime();

  // Get the SQL Query using either the sequence number or the title
  let rpt = req.body.rpt;
  console.log('-------------------------\nRPT: ' + rpt);

  var sql_query =
    "select sql_stmt from zzz_api_queries where seq = '${rpt}' or title = '${rpt}' ";
  sql_query = sql_query.replace(/\${rpt}/g, rpt);
  console.log("Get Report: " + sql_query);

  connection.query(sql_query, (err, result) => {
    if (err) throw err;
    var len1 = result.length;
    console.log("Records: " + len1);
    if (len1 == 0) {
      res.send([]);
      return;
    }
    console.log("Result: " + result[0].sql_stmt);
    var sql_query = result[0].sql_stmt;


    //  Loop thru 10 allowed input parms and replace the value in the sql statement
    let i = 0;
    for (i = 0; i < 10; i++) {
      let fld = "in" + i;
      let inp = req.body[fld];
      if (inp != undefined) {
        let fld2 = "${" + fld + "}";
        sql_query = sql_query.replace(fld2, inp);
        console.log("INPUT PARM: " + fld + " " + inp + " ");
      }
    }

    console.log("SQL: " + sql_query);

    // Execute the query and return the JSON result
    connection.query(sql_query, (err, result, fields) => {
      //if (err) throw err;
      if (err) { 
        console.log(err.stack); 
        res.send("ERROR"); 
        return ; 
       }
      var len1 = result.length;
      console.log("Records:" + len1);
      res.send(result);
    
      var end1 = new Date().getTime();
      //console.log('END:' + end1);
      var s = (end1 - beg1); 
      var ms = s % 1000;
      s = (s - ms) / 1000;
      var secs = s % 60;
      s = (s - secs) / 60;
      var mins = s % 60;
      var hrs = (s - mins) / 60;
      var diff =  mins + 'm ' + secs + 's ' + ms + 'ms';
      console.log('-------------------------\nRun Time: ' + diff + '\n-------------------------\n');
    });
  });
});

//-----------------
// POST - array
//-----------------
app.post("/app003", (req, res) => {
  // clone of app002 which returns number of affected rows (update or insert) instead of results array

  var beg1 = new Date().getTime();

  let rpt = req.body.rpt;
  console.log('-------------------------\nRPT: ' + rpt);

  var sql_query =
    "select sql_stmt from zzz_api_queries where seq = '${rpt}' or title = '${rpt}' ";
  sql_query = sql_query.replace(/\${rpt}/g, rpt);
  console.log("Get Report: " + sql_query);
 
  connection.query(sql_query, (err, result) => {
    if (err) throw err;
    var len1 = result.length;
    console.log("Records: " + len1);
    if (len1 == 0) {
      res.send([]);
      return;
    }
    console.log("Result: " + result[0].sql_stmt);
    var sql_query = result[0].sql_stmt;
 
    //  Loop thru 10 allowed input parms and replace the value in the sql statement
    let i = 0;
    for (i = 0; i < 10; i++) {
      let fld = "in" + i;
      let inp = req.body[fld];
      if (inp != undefined) {
        let fld2 = "${" + fld + "}";
        sql_query = sql_query.replace(fld2, inp);
        console.log("INPUT PARM: " + fld + " " + inp + " ");
      }
    }
 
    console.log("SQL: " + sql_query);
 
    // Execute the query and return the JSON result
    connection.query(sql_query, (err, result, fields) => {
      //if (err) throw err;
      if (err) { 
        console.log(err.stack); 
        res.send("ERROR"); 
        return ; 
       }
      var len1 = result.length;
      console.log("Records:" + len1);
      res.send( {rows: result.affectedRows} );

      var end1 = new Date().getTime();
      //console.log('END:' + end1);
      var s = (end1 - beg1); 
      var ms = s % 1000;
      s = (s - ms) / 1000;
      var secs = s % 60;
      s = (s - secs) / 60;
      var mins = s % 60;
      var hrs = (s - mins) / 60;
      var diff =  mins + 'm ' + secs + 's ' + ms + 'ms';
      console.log('-------------------------\nRun Time: ' + diff + '\n-------------------------\n');
    });
  });
 });

//--------------------------------------
// Ping to keep Azure connection active 
//--------------------------------------
function keepAlive(){
  var today1 = new Date();
  today1.toISOString().substring(0, 30);
  connection.query( "SELECT 1", (err, result) => {
  if (err) throw err;
  console.log("Ping: " + today1);
});
}

setInterval(keepAlive, 59000);