import * as React from 'react';

import styles from './ReportMaintenance.module.scss';
import { IReportMaintenanceProps } from './IReportMaintenanceProps';
import { escape } from '@microsoft/sp-lodash-subset';
import {
  SPHttpClient,
  SPHttpClientResponse
} from '@microsoft/sp-http';


export default class ReportMaintenance extends React.Component<IReportMaintenanceProps, {}> {
  public render(): React.ReactElement<IReportMaintenanceProps> { 

    this.getUserProfile();
    this.getDropDown1();
    this.getDropDown2();
    this.getDropDown3('');
    this.getDropDown4();
    this.getDropDown5();
    this.getDropDown6();
    this.getDropDown7();
    this.getDropDown();
    this.getAllUserItems();
    this.getHelpInformation();
 
    //   const { } = this.props; 
    
    const IMG1: string = this.props.context.pageContext.web.absoluteUrl+"/SiteAssets/bwm_qm0.png";
    const IMG2: string = this.props.context.pageContext.web.absoluteUrl+"/SiteAssets/image_rpt1.png";
   
    return (
     
      <div className={styles.SpFxCrud}>
          <div className={styles.container}>

          <div className={styles.row0}>         
               <div className={styles.column}>
               <table className={styles.tb0}>
                <tr>
                  <td>
                  <div id="div0" className={styles.Div0}>
                    <img src={IMG2} height={45} alt="?"></img>
                  </div>
                  <div id="div0" className={styles.Div0}>
                    <p className={styles.description}>{escape(this.props.description)}</p> 
                  </div>
                  </td>
                  <td>
                  <div id="tab01" className={styles.Div0}>
                    <div id="btn1" className={styles.tab1}>
                    <span className={styles.label} onClick={() => this.showScreen('1')}>SSI Reports</span>
                   </div>
                  </div> 
                  <div id="tab02" className={styles.Div0}>
                    <div id="btn4" className={styles.tab2}>
                    <span className={styles.label} onClick={() => this.showScreen('4')}>ZAP BI Reports</span>
                   </div>
                  </div>
                  <div id="tab03" className={styles.Div0}>
                    <div id="btn5" className={styles.tab2}>
                    <span className={styles.label} onClick={() => this.showScreen('5')}>Report Server</span>
                  </div> 
                  </div>
                  <div id="div0" className={styles.Div0}>
                    
                  </div>
                  </td>
                </tr>
                </table>  
               </div>
          </div>
            
          <div id="Div001" className={styles.Div001}>
          {/*            
          <div className={styles.row}>         
               <div className={styles.hdg1}> &nbsp;
               </div>
          </div>
          */}
           <div className={styles.row}>         
               <div className={styles.column}>
                     <div className={styles.description}> {escape(this.props.description)}</div>
               </div>
                               
               <div className={styles.column}> &nbsp;</div>
                 
               <div className={styles.column}>
                    <div className={styles.button}>
                    <span id="btn1" className={styles.label} onClick={() => this.showScreen('2')}>Add Reports</span>
                    </div> 
               </div>
   
               <div className={styles.column}>
                    <div className={styles.button2}>
                    <span  className={styles.label} onClick={this.goBackHome}>Return</span>
                    </div>   
               </div>           
              
               <div className={styles.column}>
                   <div>
                   <span id="btn3" className={styles.label} onClick={() => this.showScreen('3')}><img src={IMG1} height={25} alt="?" id="btn2"></img> &nbsp; </span> 
                   </div>
               </div>                                 
           </div>
           
           <div className={styles.row}>         
              <div className={styles.column}>     
                   <div className={styles.description2}> Name: {escape(this.props.context.pageContext.user.displayName)}</div>            
              </div>
              <div className={styles.column}>       
                   <div className={styles.description2}> User ID: {escape(this.props.context.pageContext.user.loginName)}</div>         
              </div> 
              <div className={styles.column}>       
                   <div className={styles.description2}> Department: <input id="userDEPT" type="text" readOnly disabled className={styles.txhdg} /></div>         
              </div>             
           </div>
           
           <div className={styles.row}>         
              <div className={styles.column}>               
                   <div>
                    Department:<br></br>
                   <select id="ddSYS1" onChange={this.handleChange} className={styles.txone}>
                   </select>
                  
                   </div>
              </div>  
              <div className={styles.column}>
                   <div>
                   Report Type:<br></br>
                   <select id="ddRPT1" onChange={this.handleChange} className={styles.txone}>
                   </select>
                   </div>
              </div>  
              <div className={styles.column}>
                   <div>
                   Report Date:<br></br>
                   <input id="inDate1" type="date" onChange={this.handleDate} />
                   <input id="pdDate1" type="hidden" />
                   </div>
              </div>  
              <div className={styles.column}>
                   <div id="divB1">
                   Buyer:<br></br>
                   <select id="ddBUYER1"  className={styles.txone}>
                   </select>
                   </div>
              </div>    
              <div className={styles.column}>
                   <div id="divW1">
                   Warehouse:<br></br>
                   <select id="ddWHSE1"  className={styles.txone}>
                   </select>
                   </div>     
              </div>
              <div className={styles.column}>
                   <div id="divC1">
                   Chain:<br></br>
                   <select id="ddCHAIN"  className={styles.txone}>
                   </select>
                   </div>     
              </div>
           </div>
   
           <div className={styles.row}>         
              <div className={styles.column}>                 
                  <select id="ddLIST1" onChange={this.handleSelection} className={styles.txtwo}>
                  </select>                 
              </div>
           </div>
           
           <div className={styles.row}>         
              <div className={styles.column}>    
                  <div className={styles.button}>
                     <span className={styles.label} onClick={this.ResetScreen1}>Refresh</span>
                  </div>                
                  <div className={styles.button}>
                     <span className={styles.label} onClick={this.getReport}>Submit</span>    
                  </div>
              </div>
           </div>
   
           <div className={styles.row}>         
              <div className={styles.column}>                 
                  <input type="text" id='MSG0' size={77} disabled className={styles.MSG1} value=""></input>
              </div>
           </div>
     
          </div> {/* End Div001 */}


          <div id="Div002" className={styles.Div002}>
          {/*                        
          <div className={styles.row}>         
               <div className={styles.hdg1}> &nbsp;
               </div>
          </div>
          */}

          <div className={styles.row}>         
            <div className={styles.column}>
                  <div className={styles.description}> {escape(this.props.description2)}</div>
            </div>
                            
            <div className={styles.column}> &nbsp;</div>
              
            <div className={styles.column}>
                 <div className={styles.button2}>
                 <span className={styles.label} onClick={() => this.showScreen('1')}>Return</span>
                 </div> 
            </div>
          </div>

          <div className={styles.row}>         
            <div className={styles.column}>
                  <div className={styles.description2}> Name: {escape(this.props.context.pageContext.user.displayName)}</div>
            </div>
            <div className={styles.column}>
                  <div className={styles.description2}> User ID: {escape(this.props.context.pageContext.user.loginName)}</div>
            </div>          
          </div>

          <div className={styles.row}>         
            <div className={styles.column}>
                  <div className={styles.button}>
                     <span className={styles.label} onClick={this.processChanges}>Save</span>
                  </div>
            </div>
            <div className={styles.column}>
                  <div className={styles.button}>
                     <span className={styles.label} onClick={this.ResetScreen}>Refresh</span>
                  </div>
            </div>
          </div>

          <div className={styles.row}>         
            <div className={styles.column}>
                  Department:    &nbsp;          
                  <select id="ddSYS" onChange={this.handleChange} className={styles.txone}>
                  </select>
            </div>
            <div className={styles.column}>
                  Report Type:   &nbsp;
                  <select id="ddRPT" onChange={this.handleChange} className={styles.txone}>
                  </select>
            </div>
          </div>

          <div className={styles.row}>         
            <div className={styles.column}>
                  <input type="text" id='MSG1' size={85} disabled className={styles.MSG1} value="Select a Department to Display the List of Available Reports"></input>
            </div>
          </div>

          <div className={styles.row}>         
            <div className={styles.column}>
            <div id="allItems" className={styles.tb1}></div>  
            </div>
          </div>
         
         
          <div id="allUserItems" className={styles.tb2}></div>  
  
 
        </div> {/* End of Div002 */}
               
      
        <div id="Div003" className={styles.Div003}>
          {/*                        
          <div className={styles.row}>         
               <div className={styles.hdg1}> &nbsp;
               </div>
          </div>
          */}

        <div className={styles.row}>   
            <div className={styles.column}>
                <div className={styles.description}> HELP - Information about Reports </div>      
            </div>
            <div className={styles.column}>
                <div className={styles.button2}>
                    <span className={styles.label} onClick={() => this.showScreen('1')}>Return</span>
                </div>
            </div>
        </div>                

        <div className={styles.row}>         
            <div className={styles.column}>
            <div id="allHelpInfo" className={styles.tb2}> </div>
            </div>
        </div>


        </div> {/* End of Div003 */}


        <div id="Div004" className={styles.Div004}>
              <div className={styles.contX}> 
              <div className={styles.parentX + ' ' + styles.leftX}>
     
           
                  
                  <div id="btnNav0" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('0')}>
                  <input type="text" size={25} id="descNav0" value='All Reports' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>

                  <div id="btnNav1" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('1')}>
                  <input type="text" size={25} id="descNav1" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
              
                  <div id="btnNav2" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('2')}>
                  <input type="text" size={25}  id="descNav2" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                
                  <div id="btnNav3" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('3')}>
                  <input type="text" size={25}  id="descNav3" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                 
                  <div id="btnNav4" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('4')}>
                  <input type="text" size={25}  id="descNav4" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                   
                  <div id="btnNav5" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('5')}>
                  <input type="text" size={25}  id="descNav5" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                   
                  <div id="btnNav6" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('6')}>
                  <input type="text" size={25}  id="descNav6" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                   
                  <div id="btnNav7" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('7')}>
                  <input type="text" size={25}  id="descNav7" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                   
                  <div id="btnNav8" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('8')}>
                  <input type="text" size={25}  id="descNav8" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                   
                  <div id="btnNav9" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('9')}>
                  <input type="text" size={25}  id="descNav9" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
              </div>

             
             
      {/*        </td>

              <td>
        */}
          
              <div className={styles.parentX + ' ' + styles.rightx}>
              <div id="allZapItems" className={styles.tb3}></div> 
              </div>
   


              </div>

 
        </div> {/* End of Div004 */}


        <div id="Div005" className={styles.Div005}>
        <div className={styles.row}>  
            <div className={styles.column}>       
               <div className={styles.button3}>
               <span className={styles.label}>SQL Server Reporting Services</span> 
               </div>
            </div>
        </div>              

        <div className={styles.row0}>         
            <div className={styles.column}>
            <div id="allSSRSitems" className={styles.tb2}> </div>
            </div>
        </div>


        </div> {/* End of Div005 */}

      
        </div>
     </div>
    );
    
  }

//----------------------------------------------------------------------------  
// Handle Changes to the Drop Downs
//----------------------------------------------------------------------------  
 private handleChange = (): void => {
    this.getAllItems();
    this.getDropDown3('1');
    (document.getElementById("MSG1")  as HTMLInputElement).value = `.`;      
  }
 
//----------------------------------------------------------------------------  
// Return to the calling URL.
//----------------------------------------------------------------------------  
 private goBackHome = (): void => {
  //  const url = this.props.context.pageContext.web.absoluteUrl
  //  window.open(url, "_self");  
    history.back();
  }


//----------------------------------------------------------------------------  
// Show/Hide Menus and Screens.
//---------------------------------------------------------------------------- 
private showScreen = (n: any): void => { 
  //alert('N: ' + n)

  // Hide all Screens
  var nbr_of_divs = 6;  // Total plus 1
  var i = 0;
  for (i = 1; i < nbr_of_divs; i++) { 
      var DIV1 = "Div00"+i;
      var BTN1 = "btn"+i;
     /// alert('I: ' + i + ' ' + DIV1 + ' ' + BTN1)
      var e1 = (document.getElementById(DIV1));  e1.style.display  = 'none';
      document.getElementById(BTN1).style.color="#333333";
      document.getElementById(BTN1).style.backgroundColor="#ffffff";
     
  //    document.getElementById(BTN1).addEventListener("mouseover", function() {
  //      document.getElementById(BTN1).style.backgroundColor = "#cfc3ff";
  // });
  };

  // Set active screen visible
  //alert('N: ' + i + ' ' + DIV1 + ' ' + BTN1)
  var DIV1 = "Div00"+n;
  var e1 = (document.getElementById(DIV1));  e1.style.display  = 'block';

  if (n == 2 || n == 3) { n = 1; } // Div002 and Div003 belong under Section 1
  var BTN1 = "btn"+n;
  document.getElementById(BTN1).style.color="#000000";
  document.getElementById(BTN1).style.backgroundColor="#CFC3FF";

  // Reset defaults
  //alert("HELLO");
 // (document.getElementById("btn")  as HTMLInputElement).removeAttribute("disabled");
 // (document.getElementById("btnZAP")  as HTMLInputElement).removeAttribute("disabled");
  document.getElementById("allItems").innerHTML = "";
  this.ResetScreen();
 
  if (n == '1') {  
    this.ResetScreen1();
    }

  if (n == '4') {  
    this.getZAP2('');
    (document.getElementById("MSG1")  as HTMLInputElement).hidden = true; 
    }

  if (n == '5') {  
      this.getSSRS();
      (document.getElementById("MSG1")  as HTMLInputElement).hidden = true; 
    }

}

//----------------------------------------------------------------------------  
// Get the Correct Date Values when Date is changed
//---------------------------------------------------------------------------- 
 private handleDate = (): void => {
   this.getDateValue();
  }

//----------------------------------------------------------------------------  
// When a Report is Selected get the correct Date Value and Show the Buyer
// or Warehouse Drop Downs if required 
//----------------------------------------------------------------------------  
private handleSelection = (): void => {
  this.getDateValue();
  let DATE1 = (document.getElementById("inDate1")  as HTMLSelectElement).value;
  if (DATE1 === '') { this.getDate(); DATE1 = (document.getElementById("inDate1")  as HTMLSelectElement).value; }

  (document.getElementById("MSG1")  as HTMLInputElement).value = `Report Selected`; 
  
  let e = (document.getElementById("ddLIST1") as HTMLSelectElement);
  const inLIST = e.options[e.selectedIndex].value;
  const myArray = inLIST.split('~');
 // const in1 = myArray[0];
 // const in2 = myArray[1];
  const in3 = myArray[2];
 // alert("RPT: \n" + in1 + '\n' + in2 + '\n' + in3);

  if (in3.indexOf('${Buyer}') !== -1) {   
    var eb = (document.getElementById("divB1"));
    eb.style.display  = 'block';
  } else {
    var eb = (document.getElementById("divB1"));
    eb.style.display  = 'none';
  }
  if (in3.indexOf('${Warehouse}') !== -1) {
    var ew = (document.getElementById("divW1"));
    ew.style.display  = 'block';
  } else {
    var ew = (document.getElementById("divW1"));
    ew.style.display  = 'none';
  }
  if (in3.indexOf('${Chain}') !== -1) {
    var ew = (document.getElementById("divC1"));
    ew.style.display  = 'block';
  } else {
    var ew = (document.getElementById("divC1"));
    ew.style.display  = 'none';
  }
 }

//----------------------------------------------------------------------------  
// Get the default date (yesterday) for the report if none selected.
//---------------------------------------------------------------------------- 
 private getDate = (): void => {

  var yesterday = new Date();
  yesterday.setDate(yesterday.getDate()-1);
  console.log(yesterday) // log yesterday's date 
  //alert("YD:" + yesterday)
  
  //let today = new Date();
  //let dd = today.getDate()-1;
  //let mm = today.getMonth()+1; 
  let today = yesterday;
  let dd = today.getDate();
  let mm = today.getMonth()+1; 
  let yyyy = today.getFullYear();
  let dd1 = ''+dd;
  let mm1 = ''+mm;
  let yy1 = yyyy;
  let today1 = '';
  if(dd<10) { dd1='0'+dd;} 
  if(mm<10) { mm1='0'+mm; } 

  today1 = yy1+'-'+mm1+'-'+dd1;
  //alert('TODAY: ' + today1);
  console.log(today1);
  (document.getElementById("inDate1")  as HTMLInputElement).value = today1;
  
}

//----------------------------------------------------------------------------  
// Get the Week End Date for the Date entered
//---------------------------------------------------------------------------- 
private getPreviousSunday(date: Date): Date {
 let previousSunday = date;
 const dayOfWeek = date.getDay();
 if(dayOfWeek === 6){
   previousSunday = date;
 } else{
   const daysSinceSunday = dayOfWeek === 0 ? 7 : dayOfWeek;
   previousSunday = new Date(date.getFullYear(), date.getMonth(), date.getDate() - daysSinceSunday);
 }
 return previousSunday;
}


//----------------------------------------------------------------------------  
// Get the Period End Date for the Date entered and store in a hidden field
//---------------------------------------------------------------------------- 
private getDateValue = (): void => {
 let DATE1 = (document.getElementById("inDate1")  as HTMLSelectElement).value;
 //alert('Hello:' + DATE1 + ':');
 if (DATE1 === '') { this.getDate(); DATE1 = (document.getElementById("inDate1")  as HTMLSelectElement).value; }

 this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Fiscal Calendar')/items?$filter=BEG_DATE le '${DATE1}' and END_DATE ge '${DATE1}'&$orderBy=Title&$top=999`,

 SPHttpClient.configurations.v1,
 {
   headers: {
     'Accept': 'application/json;odata=nometadata',
     'odata-version': ''
   }
 })
 .then((response: SPHttpClientResponse) => {
   if (response.ok) {
     response.json().then((responseJSON) => {
       let outDate = '';

       responseJSON.value.map((item: any, index: any) => { 
         let BEG0 = `${item.BEG_DATE}`;
         let BEG1 = BEG0.substring(0,10);
         outDate = `${BEG1}`;
       });

       let outDate1 = `${outDate}`;
       (document.getElementById("pdDate1")  as HTMLSelectElement).value = outDate1;
    //   alert("outdate: " + outDate1)
    //   alert('HTML:' + html);
       console.log(responseJSON);
    
       let MSGOK = (document.getElementById("MSG1")  as HTMLInputElement).value;
       if (MSGOK != 'Data was Saved') { 
         (document.getElementById("MSG1")  as HTMLInputElement).value = `Select/Unselect Reports and Click on 'Save' to process.`;
       }
       
     });
   } else {
     response.json().then((responseJSON) => {
       console.log(responseJSON);
       alert(`Something went wrong! Check the error in the browser console.`);
     });
   }
 }).catch(error => {
   console.log(error);
 });
}

//----------------------------------------------------------------------------  
// Get a Unique List of Departments for the Drop Down
//---------------------------------------------------------------------------- 
private getDropDown1 = (): void => {
  const id0: string = this.props.context.pageContext.user.loginName;

  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report User List')/items?$filter=UserID eq '${id0}'&$orderBy=Department,ReportType desc&$top=1000`,
 
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
 
      response.json().then((responseJSON) => {
        let key0 = '';
    //    let ctr1 = 0;
        let html = `<option value="ALL">ALL</option>`;
        responseJSON.value.map((item: any, index: any) => {
          let key1 = `${item.Department}`;
          if (key1 != key0) {
             html += `<option value="${item.Department}"> ${item.Department}`;
             key0 = key1;
          }        
    //     ctr1++;
         });
        html += `</select>`;
        document.getElementById("ddSYS1").innerHTML = html;
       // alert('HTML:' + html);
        console.log(responseJSON);             
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}

    
//----------------------------------------------------------------------------  
// Get a Unique List of Report Types from the User List for the Drop Down
//---------------------------------------------------------------------------- 
private getDropDown2 = (): void => {
  const id0: string = this.props.context.pageContext.user.loginName;
  
  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report User List')/items?$filter=UserID eq '${id0}'&$orderBy=ReportType,Department&$top=1000`,
 
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
 
      response.json().then((responseJSON) => {
        let key0 = '';
    //    let ctr1 = 0;
        let html = `<option value="ALL">ALL</option>`;
        responseJSON.value.map((item: any, index: any) => {
          let key1 = `${item.ReportType}`;
          if (key1 != key0) {
             html += `<option value="${item.ReportType}"> ${item.ReportType}`;
             key0 = key1;
          }
    //     ctr1++;
         });
        html += `</select>`;
        document.getElementById("ddRPT1").innerHTML = html;
       // alert('HTML:' + html);
        console.log(responseJSON);            
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}


//----------------------------------------------------------------------------  
// Get List of Active Reports for the UserID
//---------------------------------------------------------------------------- 
private getDropDown3 = (in1: any): void => {
  const id0: string = this.props.context.pageContext.user.loginName;
  
  let inDept = '';
  let inRpt  = '';
  let filter = '';
  if (in1 != '') {
     var e = (document.getElementById("ddSYS1") as HTMLSelectElement);
     inDept = e.options[e.selectedIndex].value;
     if (inDept != 'ALL') { filter += " and Department eq '"+inDept+"'"; }

     var e = (document.getElementById("ddRPT1") as HTMLSelectElement);
     inRpt = e.options[e.selectedIndex].value;
     if (inRpt  != 'ALL') { filter += " and ReportType eq '"+inRpt+"'"; }
   //  alert("in: " + inDept + ' ' + inRpt)
  }  

  //alert("filter: " + filter);

  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report User List')/items?$filter=UserID eq '${id0}'${filter}&$orderBy=Department,ReportType,Title&$top=1000`,
 
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
 
      response.json().then((responseJSON) => {
    //    let ctr1 = 0;
    //    let html = `<option value="ALL">ALL</option>`;
        let sp1  = '__________';
        let fld1 = '';
        let fld2 = '';
        let html = `<option value="0">* List of Active Reports *</option>`;
        responseJSON.value.map((item: any, index: any) => {          
          fld1 = `${item.Department}`+sp1;
          fld1 = fld1.substring(0,8);
          fld1 = fld1.replace(/_/g, "&nbsp;");
          fld2 = `${item.ReportType}`+sp1;
          fld2 = fld2.substring(0,8);
          fld2 = fld2.replace(/_/g, "&nbsp;");
          const OPT = `${item.Department}`+'~'+`${item.ReportType}`+'~'+`${item.URL}`;
          html +=`<option value="${OPT}"> ${fld1} ${fld2} ${item.Title}`;
      //     ctr1++;
         });
        html += `</select>`;
        document.getElementById("ddLIST1").innerHTML = html;
      //  alert('HTML:' + html);
        console.log(responseJSON);         
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}

    
//----------------------------------------------------------------------------  
// Get the list of Buyers for the Drop Down 
//---------------------------------------------------------------------------- 
private getDropDown4 = (): void => {

this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Buyers')/items?&$orderBy=Title`,

SPHttpClient.configurations.v1,
{
  headers: {
    'Accept': 'application/json;odata=nometadata',
    'odata-version': ''
  }
})
.then((response: SPHttpClientResponse) => {
  if (response.ok) {
 
    response.json().then((responseJSON) => {
  //    let ctr1 = 0;
      let html = ``;
      //html +=`<option value=""> `;
      responseJSON.value.map((item: any, index: any) => {          
        html +=`<option value="${item.Title}">${item.Title}`;
    //     ctr1++;
       });
      html += `</select>`;
      document.getElementById("ddBUYER1").innerHTML = html;
      var eb = (document.getElementById("divB1"));
      eb.style.display  = 'none';
    //  alert('HTML:' + html);
      console.log(responseJSON);         
    });
  } else {
    response.json().then((responseJSON) => {
      console.log(responseJSON);
      alert(`Something went wrong! Check the error in the browser console.`);
    });
  }
}).catch(error => {
  console.log(error);
});
}

    
//----------------------------------------------------------------------------  
// Get the list of Warehouses for the Drop Down 
//---------------------------------------------------------------------------- 
private getDropDown5 = (): void => {

this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Warehouses')/items?&$orderBy=Title`,

SPHttpClient.configurations.v1,
{
  headers: {
    'Accept': 'application/json;odata=nometadata',
    'odata-version': ''
  }
})
.then((response: SPHttpClientResponse) => {
  if (response.ok) {
 
    response.json().then((responseJSON) => {
  //    let ctr1 = 0;
      let html = ``;
      responseJSON.value.map((item: any, index: any) => {          
        html +=`<option value="${item.Title}">${item.Title}`;
    //     ctr1++;
       });
      html += `</select>`;
      document.getElementById("ddWHSE1").innerHTML = html;
      var ew = (document.getElementById("divW1"));
      ew.style.display  = 'none';
    //  alert('HTML:' + html);
      console.log(responseJSON);         
    });
  } else {
    response.json().then((responseJSON) => {
      console.log(responseJSON);
      alert(`Something went wrong! Check the error in the browser console.`);
    });
  }
}).catch(error => {
  console.log(error);
});
}

//----------------------------------------------------------------------------  
// Get a Unique List of Report Types from the Master List for the Drop Down
//---------------------------------------------------------------------------- 
private getDropDown6 = (): void => {
  
  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report Master List')/items?&$orderBy=ReportType,Department&$top=1000`,
 
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
 
      response.json().then((responseJSON) => {
        let key0 = '';
    //    let ctr1 = 0;
    //    let html = `<option value="ALL">ALL</option>`;
        let html = ``;
        responseJSON.value.map((item: any, index: any) => {
          let key1 = `${item.ReportType}`;
          if (key1 != key0) {
             html += `<option value="${item.ReportType}"> ${item.ReportType}`;
             key0 = key1;
          }
    //     ctr1++;
         });
        html += `</select>`;
        document.getElementById("ddRPT").innerHTML = html;
       // alert('HTML:' + html);
        console.log(responseJSON);            
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}

//----------------------------------------------------------------------------  
// Get the list of Chains for the Drop Down 
//---------------------------------------------------------------------------- 
private getDropDown7 = (): void => {

  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Chains')/items?&$orderBy=Title`,
  
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
   
      response.json().then((responseJSON) => {
    //    let ctr1 = 0;
        let html = ``;
        responseJSON.value.map((item: any, index: any) => {          
          html +=`<option value="${item.Title}">${item.Title}`;
      //     ctr1++;
         });
        html += `</select>`;
        document.getElementById("ddCHAIN").innerHTML = html;
        var ew = (document.getElementById("divC1"));
        ew.style.display  = 'none';
      //  alert('HTML:' + html);
        console.log(responseJSON);         
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
  }

  
private getUserProfile = (): void => {
 // alert("HELLO");
  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties`,
 //   this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties?$select=Email`,
 //   this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties?$select=DisplayName`,
 //   this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties?$select=Department`,
    SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
   // alert("Return")
  return response.json();
  })
  .then((data: any) => {
  // alert("DEPT:" + data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value);
  // alert(data.DisplayName);
  // alert(data.Email);
  var userDEPT =  data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value;
  // userDEPT = '' // testing;
  (document.getElementById("userDEPT")  as HTMLInputElement).value = userDEPT; 
   return;   
  })
  .catch((err: any) => {
    alert("ERR")
  console.log(err);
  });
  //</User, Department>
}


//----------------------------------------------------------------------------  
// Create the Report link and open the .pdf in a new tab.
//---------------------------------------------------------------------------- 
private getReport = (RB1: any): void => {
    // Department/ReportType Filter is either/or Choice
    var e = (document.getElementById("ddLIST1") as HTMLSelectElement);
    let inLIST = e.options[e.selectedIndex].value;
    const myArray = inLIST.split('~');
   // let in1 = myArray[0];
    let in2 = myArray[1];
    let in3 = myArray[2];
   // alert("RPT: \n" + in1 + '\n' + in2 + '\n' + in3);

   var inDate = (document.getElementById("inDate1")  as HTMLInputElement).value; 

   if (in2 == 'Weekly') {
      const startDatePickerElement = document.getElementById("inDate1") as HTMLInputElement;
      let startDate = startDatePickerElement.valueAsDate;
      startDate = this.getPreviousSunday(startDate);
      const selectedStartDate: string = startDate.toISOString().slice(0,10);
      inDate = selectedStartDate;
      (document.getElementById("inDate1")  as HTMLInputElement).value = inDate;
   }
   if (in2 == 'Period') {
      this.getDateValue();
      var inDate = (document.getElementById("pdDate1")  as HTMLInputElement).value; 
      (document.getElementById("inDate1")  as HTMLInputElement).value = inDate;
      // alert("Get Period End" + inDate);
   }

   
   let StartDate = inDate.replace(/-/g, '');
   //alert("inD:" + StartDate);
   let url = in3.replace('${StartDate}', StartDate);

    if (in3.indexOf('${Buyer}') !== -1) {   
      var e = (document.getElementById("ddBUYER1") as HTMLSelectElement);
      let inBUYER = e.options[e.selectedIndex].value;   
      url = url.replace('${Buyer}', inBUYER)
    } 
    if (in3.indexOf('${Warehouse}') !== -1) {
      var e = (document.getElementById("ddWHSE1") as HTMLSelectElement);
      let inWHSE = e.options[e.selectedIndex].value;  
      inWHSE = inWHSE.replace('--','');  // This is to allow viewing of report created without Warehouse parm 
      url = url.replace('${Warehouse}', inWHSE) 
    }
    if (in3.indexOf('${Chain}') !== -1) {
      var e = (document.getElementById("ddCHAIN") as HTMLSelectElement);
      let inCHAIN = e.options[e.selectedIndex].value;  
      url = url.replace('${Chain}', inCHAIN)
    }

  this.insertAuditTrail();

 //  alert("URL: " + url); 
  window.open(url, "_blank");  

}
  
//----------------------------------------------------------------------------  
// Reset Screen 1 to default values
//--------------------------------------------------------ResetScreen-------------------- 
private ResetScreen1 = (): void => {

  let html = ``;
  document.getElementById("allItems").innerHTML = html;
  (document.getElementById("ddSYS1")  as HTMLInputElement).value = 'ALL';
  (document.getElementById("ddRPT1")  as HTMLInputElement).value = 'ALL';
  (document.getElementById("ddLIST1")  as HTMLInputElement).value = '0';
  (document.getElementById("MSG0")  as HTMLInputElement).value = '';

   
  this.getUserProfile();
  this.getDate();
  this.getDropDown1();
  this.getDropDown2();
  this.getDropDown3('');
  this.getDropDown4();
  this.getDropDown5();
  this.getDropDown6();
 // 
 var eb = (document.getElementById("divB1"));
 eb.style.display  = 'none';
 var ew = (document.getElementById("divW1"));
 ew.style.display  = 'none';
 var ew = (document.getElementById("divC1"));
 ew.style.display  = 'none';
}

//----------------------------------------------------------------------------  
// Insert a record into the Audit Trail for each report requested 
//---------------------------------------------------------------------------- 
private insertAuditTrail = (): void => {
  const inID: string = this.props.context.pageContext.user.loginName;
  const inName: string = this.props.context.pageContext.user.displayName;
  let inID2 = `${inID}`;
  let inName2 = `${inName}`;
  var e = (document.getElementById("ddLIST1") as HTMLSelectElement);
  let inLIST = e.options[e.selectedIndex].value;
  let inTitle =  e.options[e.selectedIndex].text;
  const myArray = inLIST.split('~');
  let inDept = myArray[0];
  let inType = myArray[1];
  let inURL  = myArray[2];

  let today = new Date();
  let dd = today.getDate();
  let mm = today.getMonth()+1; 
  let yyyy = today.getFullYear();
  let dd1 = ''+dd;
  let mm1 = ''+mm;
  let yy1 = yyyy;
  var today1 = '';
  if(dd<10) { dd1='0'+dd;} 
  if(mm<10) { mm1='0'+mm; } 

  let hrs = today.getHours();
  let min = today.getMinutes();
  let sec = today.getSeconds();
  let min1 = ''+min;
  let sec1 = ''+sec;
  if(min<10) { min1='0'+min; }
  if(sec<10) { sec1='0'+sec; }
  let time1 = hrs+":"+min1+":"+sec1;

  today1 = yy1+'-'+mm1+'-'+dd1+' '+time1;
//  alert('TODAY: ' + today1);

  let inDate = (document.getElementById("inDate1")  as HTMLInputElement).value; 

  if (inURL.indexOf('${Buyer}') !== -1) {      
    var e = (document.getElementById("ddBUYER1") as HTMLSelectElement);
    var inBUYER = e.options[e.selectedIndex].value;
  } else {
    var inBUYER = '';
  }
  if (inURL.indexOf('${Warehouse}') !== -1) {
    var e = (document.getElementById("ddWHSE1") as HTMLSelectElement);
    var inWHSE = e.options[e.selectedIndex].value;
  } else {
    var inWHSE = '';
  }

   const body: string = JSON.stringify({
     'Title': inTitle,
     'UserID': inID2,
     'UserName': inName2, 
     'Department': inDept,
     'ReportType': inType,
     'ReportDate': inDate,
     'Buyer': inBUYER,
     'Warehouse': inWHSE,
     'RunDate': today1
   });
   this.props.context.spHttpClient.post(`${this.props.context.pageContext.web.absoluteUrl}/_api/web/lists/getbytitle('ZZZ AUDIT TRAIL')/items`,
     SPHttpClient.configurations.v1, {
     headers: {
       'Accept': 'application/json;odata=nometadata',
       'Content-type': 'application/json;odata=nometadata',
       'odata-version': ''
     },
     body: body
   })
     .then((response: SPHttpClientResponse) => {
       if (response.ok) {
         response.json().then((responseJSON) => {
           console.log(responseJSON);
          // alert(`Item created successfully with ID: ${responseJSON.ID}`);
        //   (document.getElementById("MSG1")  as HTMLInputElement).value = `Data was Saved`;
         });
       } else {
         response.json().then((responseJSON) => {
           console.log(responseJSON);
           alert(`Create: Something went wrong! Check the error in the browser console.`);
         });
       }
     }).catch(error => {
       console.log(error);
     });
      
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


//----------------------------------------------------------------------------  
// Process through the Report Security List and get the unique Departments 
// for the drop-down list.  If no entry in the list use the Default Dept.
//---------------------------------------------------------------------------- 
 private getDropDown = (): void => {
  const id0: string = this.props.context.pageContext.user.loginName;

  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report User Security')/items?$filter=UserID eq '${id0}'&$orderBy=Title&$top=1000`,
   
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
     
      response.json().then((responseJSON) => {
        var FOUND = 'NO';
        let html = `<option value="0">* Select from List *</option>`;
        responseJSON.value.map((item: any, index: any) => {
          let DPTS = `${item.Department}`;
          var myArray = DPTS.split("\n");
          for (let ix = 0; ix < myArray.length; ix++) {
              //   alert("inARRAY: " + ix + ' ' + myArray[ix]); 
              if (myArray[ix] !== '') {
                 html += `<option value="${myArray[ix]}"> ${myArray[ix]}`;
                 FOUND = 'YES';
              }
          }
         });
         
         if (FOUND == 'NO') {
            var userDPT = (document.getElementById('userDEPT')  as HTMLInputElement).value;
            html += `<option value="${userDPT}" {selected}> ${userDPT}`;
           // alert("FOUND: " + userDPT)
         }
        document.getElementById("ddSYS").innerHTML = html;
       //alert('HTML:' + html);
        console.log(responseJSON);
           
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}


//----------------------------------------------------------------------------  
// Get the List of All Active Seleted Reports for the UserID 
//---------------------------------------------------------------------------- 
private getAllUserItems = (): void => {
  
  const id0: string = this.props.context.pageContext.user.loginName;

  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report User List')/items?$filter=UserID eq '${id0}'&$orderBy=Department,ReportType&$top=999`,
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
      response.json().then((responseJSON) => {
      //  let ctr1 = 0;
        let uid1: string = this.props.context.pageContext.user.displayName;
        let html = `<table><tr><th colspan=5>List of Active Reports for: ${uid1} </th></tr>`;
        html += `<tr><th>Department</th><th>Report Type</th><th>Report Title</th>`;
        
        responseJSON.value.map((item: any, index: any) => {
          html += `<tr><td>${item.Department}</td><td>${item.ReportType}</td><td>${item.Title}</td>`;
          
      //    ctr1++;
        });
        html += `<tr><td colspan=3><hr>`;
        html += `</table>`;
        document.getElementById("allUserItems").innerHTML = html;
      
       /* const windowUrl = window.location.search;
        const params = new URLSearchParams(windowUrl);
        const URL1 = params.toString();
        let QS1 = URL1.substring(4,20);
       // alert('URL:' + URL1 + '\n' + QS1);
        if (QS1 != '') {  (document.getElementById("ddSYS")  as HTMLSelectElement).value = QS1;   }
      */
        console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}


//----------------------------------------------------------------------------  
// Process through the HTML array and check for checkbox changes.
// For each item check for a change and either Update or Delete accordingly 
//---------------------------------------------------------------------------- 
  private processChanges = (): void => {
     let ID001 = (document.getElementById("CTR1")  as HTMLInputElement).value;
     let CTRx = 0;
     CTRx = parseInt(ID001);

     let i = 0;
   
     do { 
      let ID   = (document.getElementById('ID'+i)  as HTMLInputElement).value;
      let CHK0 = (document.getElementById('cbX'+ID)  as HTMLInputElement).checked;
     // alert('CTRx: ' + i + '\n' + CHK0 + '\n' + ID);

       let CHK1 = 'false';
       if (CHK0 == true) { CHK1 = 'true'; } 
       let CHK2 = (document.getElementById('cbO'+ID)  as HTMLInputElement).value;
       let KEY1 = (document.getElementById('IDO'+ID)  as HTMLInputElement).value;

       if (CHK1 != CHK2) {      
          if (CHK0 == true) {
             //alert("TRUE: INSERT " + ID);
             this.createItem(i);            
          }
          else {
             //alert("FALSE: DELETE: " + KEY1);
             this.deleteItem(KEY1);     
          }
       }
       i++;
       } 
       while (i < CTRx && i != 999);

       this.getAllItems();
       (document.getElementById("MSG1")  as HTMLInputElement).value = `Data was Saved`;
};


//----------------------------------------------------------------------------  
// For each new item that was checked Insert a record for the UserID 
//---------------------------------------------------------------------------- 
  private createItem = (i: any): void => {

   let ID   = (document.getElementById('ID'+i)  as HTMLInputElement).value;

 //  let ID1 = (document.getElementById('ID'+i)  as HTMLInputElement).value;
 //  let ID2 = (document.getElementById('REPORT'+ID)  as HTMLInputElement).value;
 //  let ID3 = (document.getElementById('ReportType'+ID)  as HTMLInputElement).value;
 //  let ID4 = (document.getElementById('Department'+ID)  as HTMLInputElement).value;
 //  let ID5 = (document.getElementById('ReportID'+ID)  as HTMLInputElement).value;
 //  let ID6 = (document.getElementById('JobName'+ID)  as HTMLInputElement).value;
 //  let ID7 = (document.getElementById('URL'+ID)  as HTMLInputElement).value;
 //  let ID8 = (document.getElementById('SplitBy'+ID)  as HTMLInputElement).value;
 //  alert('Create: ' + ID + '\n' + ID1 + '\n' + ID2 + '\n' + ID3 + '\n' + ID4 + '\n' + ID5 + '\n' + ID6 + '\n' + ID7 + '\n' + ID8);

    const body: string = JSON.stringify({
      'Title': (document.getElementById('REPORT'+ID)  as HTMLInputElement).value,  
      'ReportNumber': (document.getElementById('ID'+i)  as HTMLInputElement).value, 
      'ReportType': (document.getElementById('ReportType'+ID)  as HTMLInputElement).value,
      'Department': (document.getElementById('Department'+ID)  as HTMLInputElement).value,
      'UserID': this.props.context.pageContext.user.loginName,
      'ReportID': (document.getElementById('ReportID'+ID)  as HTMLInputElement).value,
      'JobName': (document.getElementById('JobName'+ID)  as HTMLInputElement).value,
      'URL': (document.getElementById('URL'+ID)  as HTMLInputElement).value,
      'SplitBy': (document.getElementById('SplitBy'+ID)  as HTMLInputElement).value
    });
    this.props.context.spHttpClient.post(`${this.props.context.pageContext.web.absoluteUrl}/_api/web/lists/getbytitle('Report User List')/items`,
      SPHttpClient.configurations.v1, {
      headers: {
        'Accept': 'application/json;odata=nometadata',
        'Content-type': 'application/json;odata=nometadata',
        'odata-version': ''
      },
      body: body
    })
      .then((response: SPHttpClientResponse) => {
        if (response.ok) {
          response.json().then((responseJSON) => {
            console.log(responseJSON);
          //  alert(`Item created successfully with ID: ${responseJSON.ID}`);
            (document.getElementById("MSG1")  as HTMLInputElement).value = `Data was Saved`;
          });
        } else {
          response.json().then((responseJSON) => {
            console.log(responseJSON);
            alert(`Create: Something went wrong! Check the error in the browser console.`);
          });
        }
      }).catch(error => {
        console.log(error);
      });
   
 }
 
   
//----------------------------------------------------------------------------  
// For each new item that was un-checked Delete the record for the UserID 
//---------------------------------------------------------------------------- 
private deleteItem = (i: any): void => {

  const id: number = parseInt(i);

  if (id > 0) {
    this.props.context.spHttpClient.post(`${this.props.context.pageContext.web.absoluteUrl}/_api/web/lists/getbytitle('Report User List')/items(${id})`,
      SPHttpClient.configurations.v1,
      {
        headers: {
          'Accept': 'application/json;odata=nometadata',
          'Content-type': 'application/json;odata=verbose',
          'odata-version': '',
          'IF-MATCH': '*',
          'X-HTTP-Method': 'DELETE'
        }
      })
      .then((response: SPHttpClientResponse) => {
        if (response.ok) {
        //  alert(`Items deleted successfully!`);
        //  (document.getElementById("MSG1")  as HTMLInputElement).value = `Items: deleted successfully!`;
        }
        else {
          alert(`CRUD. DeleteItem Something went wrong!`);
          console.log(response.json());
        }
      });
  }
  else {
    alert(`Please enter a valid item id.`);
  } 
}
  

//----------------------------------------------------------------------------  
// Select the Reports from the Report Master File for the selected Department.
// Create the HTML report display list, build an array of hidden fields to 
// store the data values for the report, and set the counter for number of 
// entries in the array.  The counter/ID is the key to the array and the 
// Report ID (sequence number) is appended to the field names.  After building
// the HTML Array make a call to the sub-module to set the checkbox values.
//---------------------------------------------------------------------------- 
  private getAllItems = (): void => {
    let e = (document.getElementById("ddSYS") as HTMLSelectElement);
    let ID001 = e.options[e.selectedIndex].value;
    let ID002 = (document.getElementById("ddRPT")  as HTMLSelectElement).value;
    //alert('GetAllItems: ' + ID001 + ' ' + ID002);
 
    const id1: string = ID001;
    const id2: string = ID002;
    let ctr1 = 0;
    let row1 = 0;

    this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report Master List')/items?$filter=Department eq '${id1}' and ReportType eq '${id2}' and Active ne 'N'&$orderBy=Title&$top=999`,
   
    SPHttpClient.configurations.v1,
    {
      headers: {
        'Accept': 'application/json;odata=nometadata',
        'odata-version': ''
      }
    })
    .then((response: SPHttpClientResponse) => {
      if (response.ok) {
        response.json().then((responseJSON) => {
          let html = ` <table className={styles.tb1}><tr><th colspan=2>List of Available Reports</th></tr><td>`;
          html += ` <table className={styles.tb1}>`;
        
        //  Get number of rows in response
          var LEN1 = responseJSON.value.length;
          var CTR1 = Math.ceil(LEN1 / 2);
        //  alert("LENGTH:" + LEN1 + " " + CTR1); 
     
          responseJSON.value.map((item: any, index: any) => {
            if (row1 == CTR1) { 
              if (ctr1 != 0) {
                html += `</td></tr></table>`; 
              }
              html += `<td><table><tr>`; 
              row1 = 0;
            } 
           
            html += `<tr><td><input type="checkbox" id="cbX${item.ID}"></td><td>${item.Title}`;
            html += `<input type="hidden" id="cbO${item.ID}" value="false">`;
            html += `<input type="hidden" id="IDO${item.ID}" value="">`;
            html += `<input type="hidden" id="ID${ctr1}" value="${item.ID}">`;
            html += `<input type="hidden" id="REPORT${item.ID}" value="${item.Title}">`;
            html += `<input type="hidden" id="ReportType${item.ID}" value="${item.ReportType}">`;
            html += `<input type="hidden" id="Department${item.ID}" value="${item.Department}">`;
            html += `<input type="hidden" id="ReportID${item.ID}" value="${item.ReportID}">`;
            html += `<input type="hidden" id="JobName${item.ID}" value="${item.JobName}">`;
            html += `<input type="hidden" id="URL${item.ID}" value="${item.URL}">`;
            html += `<input type="hidden" id="SplitBy${item.ID}" value="${item.SplitBy}">`;
            ctr1++;
            row1++; 
          }); 
          html += `</td></tr></table><p><input type="hidden" id=CTR1 value='${ctr1}'>`;
          document.getElementById("allItems").innerHTML = html;
          document.getElementById("allUserItems").innerHTML = '';
          // alert('HTML:' + html);
          console.log(responseJSON);
     
          let MSGOK = (document.getElementById("MSG1")  as HTMLInputElement).value;
          if (MSGOK != 'Data was Saved') { 
            if (ctr1 == 0) {
                 (document.getElementById("MSG1")  as HTMLInputElement).value = `No Reports found for Department: ${ID001} and Report Type: ${ID002}`;
                 }
              else {
                 (document.getElementById("MSG1")  as HTMLInputElement).value = `Select/Unselect Reports and Click on 'Save' to process.`;
              }
          }
          
        }).then(() => this.findSelectedReports());;
      } else {
        response.json().then((responseJSON) => {
          console.log(responseJSON);
          alert(`Something went wrong! Check the error in the browser console.`);
        });
      }
    }).catch(error => {
      console.log(error);
    });
  }


//---------------------------------------------------------------------------- 
// Process through the list of selected reports for the UserID and set the
// HTML Checkbox to 'true' using the Report ID (sequence number).
// (sub-module Called from getAllItems)
//---------------------------------------------------------------------------- 
private findSelectedReports = (): void => {

    var e = (document.getElementById("ddRPT") as HTMLSelectElement);
    var inRPT = e.options[e.selectedIndex].value;
    var e = (document.getElementById("ddSYS") as HTMLSelectElement);
    var inSYS = e.options[e.selectedIndex].value;
  
  //  alert('Input: ' + inRPT + ' ' + inSYS);
    let FILT1 = " and ReportType eq '"+inRPT+"' and Department eq '"+inSYS+"'";
  // alert('FILTER:' + FILT1);
    const id0: string = this.props.context.pageContext.user.loginName;
    const FILTER: string = FILT1;
  
    this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report User List')/items?$filter=UserID eq '${id0}'${FILTER}&$orderBy=Department,ReportType&$top=999`,
    SPHttpClient.configurations.v1,
    {
      headers: {
        'Accept': 'application/json;odata=nometadata',
        'odata-version': ''
      }
    })
    .then((response: SPHttpClientResponse) => {
      if (response.ok) {
        response.json().then((responseJSON) => {
          responseJSON.value.map((item: any, index: any) => {
            let ID  = `${item.ReportNumber}`; 
            (document.getElementById('cbX'+ID)  as HTMLInputElement).checked = true;
            (document.getElementById('cbO'+ID)  as HTMLInputElement).value   = "true";
            (document.getElementById('IDO'+ID)  as HTMLInputElement).value   = `${item.ID}`;
          });
         
          console.log(responseJSON);
        });
      } else {
        response.json().then((responseJSON) => {
          console.log(responseJSON);
          alert(`Something went wrong! Check the error in the browser console.`);
        });
      }
    }).catch(error => {
      console.log(error);
    });
  }

 
//---------------------------------------------------------------------------- 
// Display the information on the Help Screen
//---------------------------------------------------------------------------- 
private getHelpInformation = (): void => {

  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report Help List')/items?&$orderBy=Sequence,Title&$top=999`,
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
      response.json().then((responseJSON) => {
        let html = '<table>';
        responseJSON.value.map((item: any, index: any) => {
          html += `<tr><td> ${item.Title}</td><td> ${item.field_1}</td><td> ${item.field_2}</td><td> ${item.field_3}</td></tr>`; 
        });
        html += `</table>`;
        document.getElementById("allHelpInfo").innerHTML = html;
        //  alert('HTML:' + html);
        console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}


//---------------------------------------------------------------------------- 
// Reset the Screen
//---------------------------------------------------------------------------- 
private ResetScreen = (): void => {

    let html = ``;
    document.getElementById("allItems").innerHTML = html;
    (document.getElementById("ddSYS")  as HTMLInputElement).value = "0";
   // let e = (document.getElementById("ddSYS") as HTMLSelectElement);
   // e.options.selectedIndex = 1;
    (document.getElementById("ddRPT")  as HTMLInputElement).value = 'Daily';
    (document.getElementById("MSG1")  as HTMLInputElement).value = 'Select a Department to Display the List of Available Reports';
//alert("reset")
    this.getDropDown();
    this.getAllUserItems();

}

// Get List of ZAP Reports
private getZAP2 = (n: any): void => {
   //alert("GETZAP")
   if (n == '') { n = 0; }
   var PARAMS = `&$filter=field_2 eq '${n}'`;
   if (n == '0') { PARAMS = ''; }
   //alert("GETZAP2: " + PARAMS)

   // Reset tab background colors
  let ix = 0; 
  for (ix = 0; ix < 10; ix++) { 
    //alert("IX:" + ix);
    document.getElementById("btnNav"+ix).style.backgroundColor="#FFFFFF";  
  }; 

  document.getElementById("btnNav"+n).style.backgroundColor="#CFC3FF";

  //  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('ZAP Reports')/items?${PARAMS}&$orderBy=field_2,field_1,Title&$top=999`,
    this.props.context.spHttpClient.get(`https://ssica.sharepoint.com/sites/ZAP-BI-Portal/_api/web/lists/getbytitle('ZAP Reports')/items?${PARAMS}&$orderBy=field_2,field_1,Title&$top=999`,
   SPHttpClient.configurations.v1,
   {
     headers: {
       'Accept': 'application/json;odata=nometadata',
       'odata-version': ''
     }
   })
   .then((response: SPHttpClientResponse) => {
     if (response.ok) {
      response.json().then((responseJSON) => {
        var ctr1 = 0;
        var nbr_of_groups = 0;
        var key0 = '';
        var grp0 = '';
       
        // Set up array for which groups are active (security check)
        var grpUsed = ['Y','','','','','','','','','',''];
       
        let html = `<div>`;
      // let html = `<table border=1 width=300>`;
    
        responseJSON.value.map((item: any, index: any) => {
          var key1 = `${item.field_1}`;
          var grp1 = `${item.field_2}`;

          if (grp1 != grp0) {
         // alert('New Group: ' +  key1 + ' ' + grp1);
           (document.getElementById("descNav"+grp1) as HTMLInputElement).value =  `${item.field_1}`;
           document.getElementById("btnNav"+grp1).style.border = "solid 2px #CFC3FF"; 
           nbr_of_groups++;
           var ix1 = Number(grp1);
           grpUsed[ix1] = 'Y';
           }
       
          if (key1 != key0) {
               html += ` <div style="border:none;border-width:1px;width:800px;float:left;padding:5px;margin:1px;"><b><font color=#222266 size=+0>${item.field_1}</font></b></div>`;        
          }

          // default height + dashboard overrides
          var ht1 = '45';
          if (grp1 == '4') { ht1 = '110';}
          if (grp1 == '5') { ht1 = '110';}
         
          var desc1 = `${item.field_4}`;
          var descx = '';
          var href1 = `<a href="${item.field_3}" target="_blank" style="text-decoration:none"><font color="CFC3FF">`;
          var hend1 = `</font></a>`;
         
          if (desc1 != "null") { descx = "<br><font size=-1>"+`${item.field_4}`+"</font></br>"; }
          
          html += `${href1}`;  // make entire div clickable  
          html += `<div style="border:double;border-width:3px;border-radius:7px;width:380px;height:${ht1}px;float:left;padding:0px;margin:2px;background-color:#6C67BE;"><ul style="list-style-type:none;width:355px;">`;                  
          html += `<li style="margin-bottom:6px;"><font color="white"><b>${item.Title}</b> </font><font color="#eeeeee">${descx}</font></li>`;
          html += `</div>${hend1}` 
     
          key0 = key1;
          grp0 = grp1;
             
          ctr1++;
            
        });
   
        html += `</ul></div>`;
        document.getElementById("allZapItems").innerHTML = html;
        document.getElementById("allItems").innerHTML = '';
        (document.getElementById("MSG1")  as HTMLInputElement).hidden = true; 

       // this.render();

      
        if (n == 0) { // If first time in hide unused tabs
           let ix = 0; 
           //alert('BLANK:' + nbr_of_groups + '\n' + grpUsed)
           for (ix = ix + 1; ix < 10; ix++) { 
            if (grpUsed[ix] != 'Y') { 
               document.getElementById("btnNav"+ix).style.display = 'none';   
            }
           }; 
        }

        console.log('HTML: \n' + html);
        console.log(' Nbr of Groups: ' + nbr_of_groups + '\n Nbr of Reports: ' + ctr1);
      
      
     // alert('HTML:' + html);
        console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}



// Get List of SSRS Reports
private getSSRS = (): void => {
  //alert("SSRS")
  var PARAMS = '';
  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('SRSS Report List')/items?${PARAMS}&$orderBy=Object,Title&$top=999`,
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) { 
      response.json().then((responseJSON) => {
      //  var ctr1 = 0;
    
        let html = ``;
        const IMGF: string = this.props.context.pageContext.web.absoluteUrl+"/SiteAssets/image_folder.gif";
        const IMGD: string = this.props.context.pageContext.web.absoluteUrl+"/SiteAssets/image_document.gif";

        responseJSON.value.map((item: any, index: any) => { 
          var CHK1 = `${item.Object}`;
          var IMG0 = IMGF;
          if (CHK1 == 'Report') { IMG0 = IMGD; } 
          var IMGX = `<img src=${IMG0} height={25} alt="?"></img>`;
          var link1 = `${IMGX} <a href="${item.field_1}" target="_blank" style="text-decoration:none"><font color="blue">${item.Title}</font></a>`;
          html += `<div style="border:solid;border-width:1px;border-color:#ccccff;border-radius:7px;width:275px;float:left;margin:10px;"><ul style="list-style-type:none;">`;
          html += `<p>${link1}</p>`;  
          html += `</div>`;

        });
   

        document.getElementById("allSSRSitems").innerHTML = html;
      
      //alert('HTML:' + html);
      console.log(html);
        console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}



}