import * as React from 'react';
import * as ReactDom from 'react-dom';
import { Version } from '@microsoft/sp-core-library';
import {
  IPropertyPaneConfiguration,
  PropertyPaneTextField
} from '@microsoft/sp-property-pane';
import { BaseClientSideWebPart } from '@microsoft/sp-webpart-base';
import { WebPartContext } from "@microsoft/sp-webpart-base";

import * as strings from 'CrudList001WebPartStrings';
import CrudList001 from './components/CrudList001';
import { ICrudList001Props } from './components/ICrudList001Props';

export interface ICrudList001WebPartProps {
  description: string;
  description2: string;
  spcontext:WebPartContext;
}
export interface ICrudList001State {
  description: string;
}
export default class CrudList001WebPart extends BaseClientSideWebPart<ICrudList001Props> {

  public render(): void {
    const element: React.ReactElement<ICrudList001Props> = React.createElement(
      CrudList001,
      {
        description: this.properties.description,
        description2: this.properties.description2,
        webURL:this.context.pageContext.web.absoluteUrl,
        context:this.context,
        listName: this.properties.listName
      }
    );

    ReactDom.render(element, this.domElement);
  }

  protected onDispose(): void {
    ReactDom.unmountComponentAtNode(this.domElement);
  }

  protected get dataVersion(): Version {
    return Version.parse('1.0');
  }

  protected getPropertyPaneConfiguration(): IPropertyPaneConfiguration {
    return {
      pages: [
        {
          header: {
            description: strings.PropertyPaneDescription
          },
          groups: [
            {
              groupName: strings.BasicGroupName,
              groupFields: [
                PropertyPaneTextField('description', {
                  label: strings.DescriptionFieldLabel
                })
              ]
            }
          ]
        }
      ]
    };
  }
}
