import * as React from 'react';

import styles from './CrudList001.module.scss';
import { ICrudList001Props } from './ICrudList001Props';
import { escape } from '@microsoft/sp-lodash-subset';
import {
  SPHttpClient,
  SPHttpClientResponse
} from '@microsoft/sp-http';


export default class CrudList001 extends React.Component<ICrudList001Props, {}> {
  public render(): React.ReactElement<ICrudList001Props> { 

    this.getDropDown();
    this.getSecurityList();
 
    // const {  } = this.props;

    //const IMG1: string = this.props.context.pageContext.web.absoluteUrl+"/SiteAssets/bwm_qm0.png";
    const IMG1: string = "https://ssica.sharepoint.com/SiteAssets/bwm_qm0.png";
   
    return (
      <div className={styles.SpFxCrud}>
        <div className={styles.container}>

        {/* DIV002 - Main Security Screen */}
        <div id="Div001" className={styles.Div001}>

          <div className={styles.row}>         
               <div className={styles.hdg1}> &nbsp;
               </div>
          </div>

          <div className={styles.row}>         
            <div className={styles.column}>
                  <div className={styles.description}> {escape(this.props.description)}</div>
                  <p>[ Points to security list in SharePoint / Home / Reports ]</p>
            </div>

            <div className={styles.column}> &nbsp;</div>
                 
            <div className={styles.column}>
               <button className={styles.button} onClick={this.show2}>Audit Trail</button> 
            </div>
               
            <div className={styles.column}>
               <button className={styles.button2} onClick={this.goBackHome}>Return</button>
            </div>

            <div className={styles.column}>
                   <div>
                   <span className={styles.label} onClick={this.show3}><img src={IMG1} height={25} alt="?"></img> &nbsp; </span> 
                   </div>
            </div> 
          </div>

          <div className={styles.row}>         
            <div className={styles.column}>
                  <div className={styles.description2}> Name: {escape(this.props.context.pageContext.user.displayName)}</div>
            </div>
            <div className={styles.column}>
                  <div className={styles.description2}> User ID: {escape(this.props.context.pageContext.user.loginName)}</div>
            </div>          
          </div>

          <div className={styles.row}>     
       {/*     <div id="btnSelect" className={styles.column}>
                  <div className={styles.button}>
                     <span className={styles.label} onClick={this.selectItem}>Select</span>
                  </div>
            </div>
            <div id="btnAdd" className={styles.column}>
                  <div className={styles.button}>
                     <span className={styles.label} onClick={this.createItem}>Add</span>
                  </div>                                 
            </div>

            <div id="btnSave" className={styles.column}>
                  <div className={styles.button}>
                     <span className={styles.label} onClick={this.updateItem}>Save</span>
                  </div>
            </div>
            <div id="btnDelete" className={styles.column}>
                  <div className={styles.button}>
                     <span className={styles.label} onClick={this.deleteItem}>Delete</span>
                  </div>
            </div>
            <div id="btnRefresh" className={styles.column}>
                  <div className={styles.button}>
                     <span className={styles.label} onClick={this.ResetScreen}>Refresh</span>
                  </div>
            </div>
                */}
            <div id="btnSelect" className={styles.column}>
                  <button className={styles.button} onClick={this.selectItem}>Select</button>                               
            </div>
            <div id="btnAdd" className={styles.column}>
                  <button className={styles.button} onClick={this.createItem}>Add</button>                               
            </div>
            <div id="btnSave" className={styles.column}>
                  <button className={styles.button} onClick={this.updateItem}>Save</button>                               
            </div>
            <div id="btnDelete" className={styles.column}>
                  <button className={styles.button} onClick={this.deleteItem}>Delete</button>                               
            </div>
            <div id="btnRefresh" className={styles.column}>
                  <button className={styles.button} onClick={this.ResetScreen}>Refresh</button>                               
            </div>

          </div>

          <div className={styles.row}>         
            <div className={styles.column}>
                  <input type="text" id='MSG1' size={100} disabled className={styles.MSG1} value="Select a User from the list to update.   Click on 'Add' to create a new User."></input>
            </div>
          </div>

          <div id="divUSER" className={styles.row}>         
            <div className={styles.column}>
                  Userid:    &nbsp;          
                  <input type="text" id="inUserID" onChange={this.handleChange} className={styles.txone}>
                  </input>
                  <input type="hidden" id="IDS" className={styles.txone}>
                  </input>
            </div>
            <div className={styles.column}>
                  Name:    &nbsp;          
                  <input type="text" id="inUserName" size={50} readOnly className={styles.txtwo}>
                  </input>

            </div>
          </div>
          <div id="divDepts" className={styles.row}>         
            <div className={styles.column}>
               <div  className={styles.tb1}>
                 <input type="checkbox" id="chkALL" onChange={this.handleChange} className={styles.tb1}> 
                 </input> Check ALL Departments
               </div>
            </div>
          </div>

          <div className={styles.row}>         
            <div className={styles.column}>  
               <div id="allDepts" className={styles.tb1}></div>  
            </div>  
          </div>

          <div className={styles.row}>         
            <div className={styles.column}>
            <div id="allItems" className={styles.tb1}></div>  
            </div>
          </div>
         
         
          <div id="allUserItems" className={styles.tb1}></div>  

        </div>  {/* END OF DIV001 */}
        
        {/* DIV002 - Audit Trail */}
        <div id="Div002" className={styles.Div003}>
           <div className={styles.row}>         
               <div className={styles.hdg1}> &nbsp;
               </div>
           </div>

           <div className={styles.row}>         
              <div className={styles.column}>
                  <div className={styles.description}> {escape(this.props.description2)}</div>
              </div>
                                    
        {/*      <div id="test1" className={styles.column}>
                  <div className={styles.button}>
                     <span className={styles.label} onClick={this.getUserProfile}>My Profile</span>
                  </div>
              </div>  */}
                            
              <div className={styles.column}> &nbsp;</div>
              
              <div className={styles.column}>
                 <button className={styles.button2} onClick={this.show1}>Return</button>
              </div>
            </div>
                 
            <div className={styles.row}>         
               <div className={styles.column}> 
                   <select id="ddAUDIT"  className={styles.txone}>
                   <option value="1">Date</option>
                   <option value="2" selected>User</option>
                   <option value="3">Report Name</option>
                   <option value="4">Detail Report</option>
                   </select>              
               </div>
               <div className={styles.column}>  
                   <select id="ddANAME"  className={styles.txone}>
                   <option value='' selected> - Select Name - </option>
                   </select>     
               </div>
               <div className={styles.column}>  
                   <select id="ddADATE"  className={styles.txone}>
                   <option value='' selected> - Select Date - </option>
                   </select>     
               </div>
               <div className={styles.column}>  
                  <button className={styles.button} onClick={this.getAuditTrail}>Get Report</button>    
               </div>
               <div className={styles.column}>  
                  <button className={styles.button2} onClick={this.show2}>Refresh</button>    
               </div>
            </div>

            <div id="allAuditItems" className={styles.tb1}></div>  

        </div>  {/* END OF DIV002 */}

        {/* DIV003 - Help and Information */}
        <div id="Div003" className={styles.Div002}>
         <div className={styles.row}>         
               <div className={styles.hdg1}> &nbsp;
               </div>
         </div>

         <div className={styles.row}>   
            <div className={styles.column}>
                <div className={styles.description}> HELP - Information about Reports </div>      
            </div>
            <div className={styles.column}>
                <div className={styles.button2}>
                    <span className={styles.label} onClick={this.show1}>Return</span>
                </div>
            </div>
         </div>

        </div>  {/* END OF DIV003 */}

        </div>
      </div>
      
    );
   
  }

  
//----------------------------------------------------------------------------  
// Show Screen1.  Report Security.  Hide Screen2 and Help Menu.
//----------------------------------------------------------------------------  
 private show1 = (): void => {
  let e1 = (document.getElementById("Div001"));
  e1.style.display  = 'block';
  let e2 = (document.getElementById("Div002"));
  e2.style.display  = 'none';
  let e3 = (document.getElementById("Div003"));
  e3.style.display  = 'none';
  this.ResetScreen();
 }

//----------------------------------------------------------------------------  
// Show Screen2. Audit Trail Reports.  Hide Screen1 and Help Menu.
//---------------------------------------------------------------------------- 
private show2 = (): void => { 
  var e1 = (document.getElementById("Div001"));
  e1.style.display  = 'none';
  var e2 = (document.getElementById("Div002"));
  e2.style.display  = 'block';
  var e3 = (document.getElementById("Div003"));
  e3.style.display  = 'none';
  this.getAuditDropDown1();
  this.getAuditDropDown2();
  (document.getElementById("ddAUDIT") as HTMLSelectElement).value = '2';
  (document.getElementById("ddANAME") as HTMLSelectElement).value = '';
  (document.getElementById("ddADATE") as HTMLSelectElement).value = '';
  this.getAuditTrail();
}

//----------------------------------------------------------------------------  
// Show Help Menu.  Hide Screen1 and Screen2.
//---------------------------------------------------------------------------- 
private show3 = (): void => { 
var e1 = (document.getElementById("Div001"));
e1.style.display  = 'none';
var e2 = (document.getElementById("Div002"));
e2.style.display  = 'none';
var e3 = (document.getElementById("Div003"));
e3.style.display  = 'block';
this.ResetScreen();
}


/*
//----------------------------------------------------------------------------  
// Test Department Lookup
//---------------------------------------------------------------------------- 
private getUserName = (): void => { 
  var DPT = this.getUserProfile();
  alert ("Your Department is: " + DPT);
  }
*/

//----------------------------------------------------------------------------  
// Handle Changes to the Drop Downs
//----------------------------------------------------------------------------  
private handleChange = (): void => {
  let chkALL = (document.getElementById("chkALL")  as HTMLInputElement).checked;

  if (chkALL == true) {
     let ID0 = (document.getElementById("CTR1")  as HTMLInputElement).value;
     let CTRx = 0;
     CTRx = parseInt(ID0);

     let i = 0;

     do {  
       (document.getElementById('DPT'+i)  as HTMLInputElement).checked = true;
       i++;
     } 
      while (i < CTRx && i != 999);
     (document.getElementById("chkALL")  as HTMLInputElement).checked = false;
     (document.getElementById("MSG1")  as HTMLInputElement).value = `All Departments Seleted. Click on 'Add' or 'Save' to process.`;      
   }
}

private getUserProfile = (): void => {
 //alert("HELLO"); 
 var UID = (document.getElementById('inUserID')  as HTMLInputElement).value;

 var GET = `GetMyProperties`;
 
 if (UID != '')
 {
    GET = `GetPropertiesFor(accountName=@v)?@v='i:0%23.f|membership|${UID}'`;
//    GET = `GetPropertiesFor(accountName=@v)?@v='i:0%23.f|membership|bwmmis1@ssica.com'`;
 }

 //alert("WHOM: " + GET);

//this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties`,

 this.props.context.spHttpClient.get(`https://ssica.sharepoint.com/_api/SP.UserProfiles.PeopleManager/${GET}`,

 SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
   // alert("Return")
   
  return response.json();
  })
  .then((data: any) => {

  //   alert("Your Department is: " + data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value);
  // alert(data.DisplayName); 
   (document.getElementById('inUserName') as HTMLInputElement).value = data.DisplayName;
   if (data.DisplayName == undefined) {
    (document.getElementById("MSG1")  as HTMLInputElement).value = `UserID was not found. Make changes and click on "Save" to validate.`;
     alert("UserID was not found.  Change and click 'Save' to validate, then assign departments.");
   }

 // var results = data.UserProfileProperties;
 // var html = `<table><tr><th> User Profie</th><th>Value</th></tr>`;
 // var i=0;
 // for (i = 0; i < results.length; i++) { 
 //     html += `<tr><td> ${results[i].Key}</td><td> ${results[i].Value} </td></tr>`;
 //  };

 // html += `</table>`;
 // document.getElementById("allAuditItems").innerHTML = html;
  //alert('HTML:' + html);

  // return data.UserProfileProperties.find((p: any) => p.Key === 'DisplayName').Value;
  //alert(data.DisplayName);
  //alert(data.Email);
  //alert("DEPT:" + data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value);
  //alert("PHON:" + data.UserProfileProperties.find((p: any) => p.Key === 'WorkPhone').Value);
  //alert("ACCT:" + data.UserProfileProperties.find((p: any) => p.Key === 'AccountName').Value);
  //alert("SPSD:" + data.UserProfileProperties.find((p: any) => p.Key === 'SPS-Department').Value);
  })
  .catch((err: any) => {
    alert("ERR")
  console.log(err);
  });
  //</User, Department>
}

//----------------------------------------------------------------------------  
// Return to the calling URL.
//----------------------------------------------------------------------------  
private goBackHome = (): void => {
//  const url = this.props.context.pageContext.web.absoluteUrl
//  window.open(url, "_self");  
  history.back();
}

//----------------------------------------------------------------------------  
// Process through the HTML array and check for Selected Entry.
//---------------------------------------------------------------------------- 
private selectItem = (): void => {
  let CTR001 = (document.getElementById("CTR2")  as HTMLInputElement).value;
  let CTRx = 0;
  CTRx = parseInt(CTR001);

  let i = 0;

  do { 
    let CHK0  = (document.getElementById('cbS'+i)  as HTMLInputElement).checked;
    let IDS   = (document.getElementById('IDS'+i)  as HTMLInputElement).value;
    let UID   = (document.getElementById('UID'+i)  as HTMLInputElement).value;
    let UIX   = (document.getElementById('UIX'+i)  as HTMLInputElement).value;
 
 
    if (CHK0 == true) {
       (document.getElementById('IDS')  as HTMLInputElement).value = IDS;
       (document.getElementById('inUserID')  as HTMLInputElement).value = UID;
       (document.getElementById('inUserName') as HTMLInputElement).value = UIX;
       var DPTS  = (document.getElementById('DPX'+i)  as HTMLInputElement).value;
       (document.getElementById("MSG1")  as HTMLInputElement).value = `Make changes and click on "Save" to process.`;
      // let DPT   = (document.getElementById('DPX'+i)  as HTMLInputElement).value;
      // alert('choose CTR: ' + i + '\n' + CHK0 + '\n' + IDS + '\n' + UID + '\n' + UIX + '\n' + DPT);
      // document.getElementById("allUserItems").innerHTML = ""; 
    }

    i++;
    } 
    while (i < CTRx && i != 999);

  //

  var myArray = DPTS.split("\n");
// Testing...  
//  for (let ix = 0; ix < myArray.length; ix++) {
//       alert("inARRAY: " + ix + ' ' + myArray[ix]); 
//  }

// Process thru all of the checkboxes and set the value if they are active in the User Array from the multi-line list
  let ID004 = (document.getElementById("CTR1")  as HTMLInputElement).value;
  let CTRy = 0;
  CTRy = parseInt(ID004);

  let i2 = 0;
  do { 
      let inDPT =  (document.getElementById('DPT'+i2)  as HTMLInputElement).value;
  
      for (let ix = 0; ix < myArray.length; ix++) {
        if (inDPT == myArray[ix]) {
          // alert("ARRAY: " + ix + ' ' + myArray[ix]); 
           (document.getElementById('DPT'+i2)  as HTMLInputElement).checked = true;
        }
     }
     i2++;
  } 
  while (i2 < CTRy && i2 != 999);

  document.getElementById("btnSave").style.display = 'block';
  document.getElementById("btnSelect").style.display = 'none';
  document.getElementById("btnAdd").style.display = 'none';
  document.getElementById("btnDelete").style.display = 'block';
  document.getElementById("btnRefresh").style.display = 'block';
  document.getElementById("allDepts").style.display = 'block';
  document.getElementById("divDepts").style.display = 'block';
  document.getElementById("divUSER").style.display = 'block';
 // (document.getElementById("inUserID") as HTMLInputElement).readOnly = true;
 // (document.getElementById("inUserName") as HTMLInputElement).readOnly = true;
  document.getElementById("allItems").style.display = 'none';
  document.getElementById("allUserItems").style.display = 'none';
      
};


//----------------------------------------------------------------------------  
// Process through the Report Master List and get the unique Departments 
// for the drop-down list.
//---------------------------------------------------------------------------- 
private getDropDown = (): void => {
 
//  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report Master List')/items?&$orderBy=Department&$top=1000`,
  this.props.context.spHttpClient.get(`https://ssica.sharepoint.com/_api/web/lists/getbytitle('Report Master List')/items?&$orderBy=Department&$top=1000`,

  
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
     
      response.json().then((responseJSON) => {
        let key0 = '';
        let ctr1 = 0;
       // let ctr2 = 0;
        let html = ``;
        responseJSON.value.map((item: any, index: any) => {
          let key1 = `${item.Department}`;
          if (key1 != key0) {
             html += `<input type="checkbox" id="DPT${ctr1}" value="${item.Department}"> ${item.Department} &nbsp; &nbsp;`;
           // html += `<input type="checkbox" id="DPT${ctr1}" name="DPTX${item.Department}" value="${item.Department}"> ${item.Department} &nbsp;`;
             key0 = key1;
             ctr1++;
        //     ctr2++;
        //     if (ctr2 == 6) { html += `<br>`; ctr2=0; }
          }

         });
         html += `<input type="hidden" id=CTR1 value='${ctr1}'>`;
        document.getElementById("allDepts").innerHTML = html;
       //alert('HTML:' + html);
        console.log(responseJSON);
           
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}


//----------------------------------------------------------------------------  
// Get the List of All Users with Security Overrides
//---------------------------------------------------------------------------- 
private getSecurityList = (): void => {
  
   // this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report User Security')/items?&$orderBy=UserID,Title&$top=999`,
   this.props.context.spHttpClient.get(`https://ssica.sharepoint.com/_api/web/lists/getbytitle('Report User Security')/items?&$orderBy=UserID,Title&$top=999`,
   SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
      response.json().then((responseJSON) => {
        let ctr1 = 0;
        let html = `<table><tr><th></th><th colspan=3>List of Active Users:  </th></tr>`;
        html += `<tr><th></th><th>Name</th><th>UserID</th><th>Departments</th>`;
       
        responseJSON.value.map((item: any, index: any) => {
          let link1 = `<input type="checkbox" id="cbS${ctr1}">`;
          link1 += `<input type="hidden"  id="IDS${ctr1}" value="${item.ID}">`;
          link1 += `<input type="hidden"  id="UID${ctr1}" value="${item.UserID}">`;
          link1 += `<input type="hidden"  id="UIX${ctr1}" value="${item.Title}">`;
          link1 += `<textarea id="DPX${ctr1}" hidden>${item.Department}</textarea>`;
          html += `<tr> <td> ${link1} </td><td>${item.Title}</td><td>${item.UserID}</td><td>${item.Department}</td>`;
          
          ctr1++;
        });
        html += `<tr><td colspan=4><hr>`;
        html += `</table>`;
        html += `<input type="hidden" id=CTR2 value='${ctr1}'>`;
        document.getElementById("allUserItems").innerHTML = html;
        //alert("HTML:" + html);

        document.getElementById("btnSave").style.display = 'none';
        document.getElementById("btnSelect").style.display = 'block';
        document.getElementById("btnAdd").style.display = 'block';
        document.getElementById("btnDelete").style.display = 'none';
        document.getElementById("btnRefresh").style.display = 'none';
        document.getElementById("allDepts").style.display = 'none';
        document.getElementById("divDepts").style.display = 'none';
        document.getElementById("divUSER").style.display = 'none';
         
        console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}


//----------------------------------------------------------------------------  
// Validate the input and Insert a record for the UserID 
//---------------------------------------------------------------------------- 
private createItem = (id: any): void => {

//----------------------------------------------------------------------------  
// Validat the input fields
//---------------------------------------------------------------------------- 

   let inUSER   = (document.getElementById('inUserID')  as HTMLInputElement).value;

   if (inUSER == '') {
    (document.getElementById("inUserID")  as HTMLInputElement).value = "";
    (document.getElementById("inUserName")  as HTMLInputElement).value = ""; 
    document.getElementById("allUserItems").style.display = 'none';
    document.getElementById("allDepts").style.display = 'block';
    document.getElementById("divDepts").style.display = 'block';
    document.getElementById("divUSER").style.display = 'block';
//    (document.getElementById("inUserID") as HTMLInputElement).readOnly = false;
//    (document.getElementById("inUserName") as HTMLInputElement).readOnly = false;

    let CTR000 = (document.getElementById("CTR1")  as HTMLInputElement).value;
    let CTRx = 0;
    CTRx = parseInt(CTR000);

    let i = 0;

    do {  
      (document.getElementById('DPT'+i)  as HTMLInputElement).checked = false;
      i++;
    } 
     while (i < CTRx && i != 999);

     document.getElementById("btnSave").style.display = 'none';
     document.getElementById("btnSelect").style.display = 'none';
     document.getElementById("btnAdd").style.display = 'block';
     document.getElementById("btnDelete").style.display = 'none';
     document.getElementById("btnRefresh").style.display = 'block';
     document.getElementById("divDepts").style.display = 'none';
     document.getElementById("allDepts").style.display = 'none';
     (document.getElementById("MSG1")  as HTMLInputElement).value = `Enter UserID and click on 'Add' to create a new entry`;


    // alert("ADD NEW")
    return;
   }

   this.getUserProfile();

//----------------------------------------------------------------------------  
// Process through the HTML array and check for selected departments and
// concatenate the values into the multi-line string. 
//---------------------------------------------------------------------------- 

let CTR001 = (document.getElementById("CTR1")  as HTMLInputElement).value;
let CTRx = 0;
CTRx = parseInt(CTR001);
//alert("ADD NEW:" + CTRx)
var DPT = ''; 
let i = 0;

do {
  let inDPT = (document.getElementById('DPT'+i)  as HTMLInputElement).value;
  let CHK0 = (document.getElementById('DPT'+i)  as HTMLInputElement).checked;
  if (CHK0 == true) { 
     DPT += "\n"+inDPT;
    // alert("DPT:" + DPT)
   }         

  i++;
  } 
  while (i < CTRx && i != 999);

  //alert("ADD NEW:" + DPT)

    let inUserName = (document.getElementById('inUserName')  as HTMLInputElement).value;
    let inUserID = (document.getElementById('inUserID')  as HTMLInputElement).value;

    const body: string = JSON.stringify({
      'Title': inUserName,  
      'UserID': inUserID, 
      'Department': DPT
    });
   // this.props.context.spHttpClient.post(`${this.props.context.pageContext.web.absoluteUrl}/_api/web/lists/getbytitle('Report User Security')/items`,
      this.props.context.spHttpClient.post(`https://ssica.sharepoint.com/_api/web/lists/getbytitle('Report User Security')/items`,
      SPHttpClient.configurations.v1, {
      headers: {
        'Accept': 'application/json;odata=nometadata',
        'Content-type': 'application/json;odata=nometadata',
        'odata-version': ''
      },
      body: body
    })
      .then((response: SPHttpClientResponse) => {
        if (response.ok) {
          response.json().then((responseJSON) => {
            console.log(responseJSON);
           // alert(`Item created successfully with ID: ${responseJSON.ID}`);
            (document.getElementById("MSG1")  as HTMLInputElement).value = `Record was added. Click on 'Save' to process changes. Click on 'Add' to add another new entry.`;
            document.getElementById("btnSave").style.display = 'block';
            document.getElementById("divDepts").style.display = 'block';
            document.getElementById("allDepts").style.display = 'block';
            (document.getElementById("IDS")  as HTMLInputElement).value = `${responseJSON.ID}`;
          });
        } else {
          response.json().then((responseJSON) => {
            console.log(responseJSON);
            alert(`Create: Something went wrong! Check the error in the browser console.`);
          });
        }
      }).catch(error => {
        console.log(error);
      });
   
 }
 
//----------------------------------------------------------------------------  
// Updat the Data for the UserID
//---------------------------------------------------------------------------- 
private updateItem = (): void => {

//----------------------------------------------------------------------------  
// Process through the HTML array and check for selected departments and
// concatenate the values into the multi-line string. 
//---------------------------------------------------------------------------- 

  let ID0 = (document.getElementById("CTR1")  as HTMLInputElement).value;
  let CTRx = 0;
  CTRx = parseInt(ID0);

  let i = 0;
  var DPT = ''; 

  do {
    let inDPT   = (document.getElementById('DPT'+i)  as HTMLInputElement).value;
    let CHK0 = (document.getElementById('DPT'+i)  as HTMLInputElement).checked;
    if (CHK0 == true) { 
       DPT += inDPT+"\n";
      // alert("DPTx:" + DPT)
     }         

    i++;
    } 
    while (i < CTRx && i != 999);

    this.getUserProfile();

   let ID1 = (document.getElementById("IDS")  as HTMLInputElement).value;
   const id: number = parseInt(ID1);
   //alert("Update:" +ID1 + ' ' + DPT)

   let inUserName = (document.getElementById('inUserName')  as HTMLInputElement).value;
   let inUserID = (document.getElementById('inUserID')  as HTMLInputElement).value;

   const body: string = JSON.stringify({
     'Title': inUserName,  
     'UserID': inUserID, 
     'Department': DPT
   });

  //this.props.context.spHttpClient.post(`${this.props.context.pageContext.web.absoluteUrl}/_api/web/lists/getbytitle('Report User Security')/items(${id})`, 
  this.props.context.spHttpClient.post(`https://ssica.sharepoint.com/_api/web/lists/getbytitle('Report User Security')/items(${id})`, 
   SPHttpClient.configurations.v1, {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'Content-type': 'application/json;odata=nometadata',
      'odata-version': '',
      'IF-MATCH': '*',
      'X-HTTP-Method': 'MERGE'
    },
    body: body
  })
    .then((response: SPHttpClientResponse) => {
      if (response.ok) {
         //alert(`Item with ID: ${id} updated successfully!`);
         (document.getElementById("MSG1")  as HTMLInputElement).value = `Data was saved.`;
       } else {
         response.json().then((responseJSON) => {
           console.log(responseJSON);
           alert(`Something went wrong! Check the error in the browser console.`);
         });
       }
    }).catch(error => {
      console.log(error);
    });
 
}
 

//----------------------------------------------------------------------------  
// Delete Item from the List 
//---------------------------------------------------------------------------- 
private deleteItem = (): void => {

  let VERIFY  = (document.getElementById('MSG1')  as HTMLInputElement).value;
  //alert('DELETE:' + VERIFY);
  if (VERIFY == "Click on 'Delete' again to confirm.") {
  }
  else {
    (document.getElementById('MSG1')  as HTMLInputElement).value = "Click on 'Delete' again to confirm.";
    return;
  }

  let ID1 = (document.getElementById("IDS")  as HTMLInputElement).value;
  const id: number = parseInt(ID1);

  if (id > 0) {
    //this.props.context.spHttpClient.post(`${this.props.context.pageContext.web.absoluteUrl}/_api/web/lists/getbytitle('Report User Security')/items(${id})`,
    this.props.context.spHttpClient.post(`https://ssica.sharepoint.com/_api/web/lists/getbytitle('Report User Security')/items(${id})`,
     SPHttpClient.configurations.v1,
      {
        headers: {
          'Accept': 'application/json;odata=nometadata',
          'Content-type': 'application/json;odata=verbose',
          'odata-version': '',
          'IF-MATCH': '*',
          'X-HTTP-Method': 'DELETE'
        }
      })
      .then((response: SPHttpClientResponse) => {
        if (response.ok) {
        //  alert(`Items deleted successfully!`);
          (document.getElementById("MSG1")  as HTMLInputElement).value = `Delete was successful`;
          document.getElementById("btnSave").style.display = 'none';
          document.getElementById("btnDelete").style.display = 'none';
          document.getElementById("allDepts").style.display = 'none';
          document.getElementById("divDepts").style.display = 'none';
          document.getElementById("divUSER").style.display = 'none';
        }
        else {
          alert(`CRUD. DeleteItem Something went wrong!`);
          console.log(response.json());
        }
      });
  }
  else {
    alert(`Please enter a valid item id.`);
  } 
}
  
 
//---------------------------------------------------------------------------- 
// Reset the Screen
//---------------------------------------------------------------------------- 
private ResetScreen = (): void => {

    let html = ``;
    document.getElementById("allItems").innerHTML = html;
    (document.getElementById("inUserID")  as HTMLInputElement).value = "";
    (document.getElementById("inUserName")  as HTMLInputElement).value = "";
    document.getElementById("allDepts").style.display = 'none';
    document.getElementById("divDepts").style.display = 'none';
    document.getElementById("divUSER").style.display = 'none';
    document.getElementById("allItems").style.display = 'block';
    document.getElementById("allUserItems").style.display = 'block';
    (document.getElementById("MSG1")  as HTMLInputElement).value = `Select a User from the list to update.   Click on 'Add' to create a new User.`;
  //alert("reset")
    this.getSecurityList();

}
  
// Get all items for UserID
private getAuditTrail = (): void => {

  var inRPT = '2';
  var inANAME = '';
  var inADATE = '';
  var OBY = '';
  var e = (document.getElementById("ddAUDIT") as HTMLSelectElement);
  inRPT = e.options[e.selectedIndex].value;
  if (inRPT == '1') { var field = 'RunDate'; OBY = ' desc'; }   
  if (inRPT == '2') { var field = 'UserName'; }  
  if (inRPT == '3') { var field = 'Title'; }  
  if (inRPT == '4') { var field = 'Title,RunDate,UserName'; }  
  const PARAMS: string = "&$orderBy="+field+OBY;

  var e = (document.getElementById("ddANAME") as HTMLSelectElement);
  inANAME = e.options[e.selectedIndex].value;
 // if (typeof(e) != 'undefined' && e != null) {
 //    inANAME = e.options[e.selectedIndex].value;
 // }

  var e = (document.getElementById("ddADATE") as HTMLSelectElement);
  inADATE = e.options[e.selectedIndex].value;

  //alert("NAME: " + inANAME + "  DATE: " + inADATE);

 // this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('ZZZ AUDIT TRAIL')/items?${PARAMS}&$top=5000`,
  this.props.context.spHttpClient.get(`https://ssica.sharepoint.com/_api/web/lists/getbytitle('ZZZ AUDIT TRAIL')/items?${PARAMS}&$top=5000`,
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
      response.json().then((responseJSON) => {
        var ctr1 = 0;
        var ctr2 = 0;
        var ctr9 = 0;
        var key0 = '';

        let html = `<table><tr><th colspan=5>Audit Trail Reports</th></tr>`;
        html += `<tr><th>Description</th><th>Number of Reports</th>`;
     
        responseJSON.value.map((item: any, index: any) => {
          if (inRPT == '1') { var key1 = `${item.RunDate}`; key1 = key1.substring(0,10); }
          if (inRPT == '2') { var key1 = `${item.UserName}`+" "+`${item.UserID}`; }
          if (inRPT == '3') { var key1 = `${item.Title}`; }
          var keyx = `${item.RunDate}`; keyx = keyx.substring(0,10);
          if (inRPT == '4') { var key1 = `${item.Title}`+" "+`${item.UserName}`+" "+keyx+" "+`${item.UserID}`; }
          
        
          // Match Date and UserID if Selected
          if ((inADATE == '' && inANAME == '') ||
          (inANAME == '' && inADATE != '' && inADATE == keyx) ||
          (inADATE == '' && inANAME != '' && inANAME == `${item.UserID}`) || 
          (inADATE != '' && inADATE == keyx && inANAME != '' && inANAME == `${item.UserID}`) ) 
           {

             if (key1 != key0) {
          
                if (ctr1 != 0) {
                 html += `<tr><td>${key0}</td><td style="text-align:right;"> ${ctr1}</td></tr>`;
                }
                key0 = key1;
                ctr1=0;
                ctr2++;
              }

             ctr1++;
             ctr9++;
           }
        });
        html += `<tr><td>${key0}</td><td style="text-align:right;"> ${ctr1} </td><tr>`;
        html += `<tr><td>Count: &nbsp; ${ctr2}</td><td style="text-align:right;">Total: &nbsp; ${ctr9} </td><tr>`;
        html += `</table>`;
        document.getElementById("allAuditItems").innerHTML = html;
 
        console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}

// Get all UserIDs
private getAuditDropDown1 = (): void => {
 
  const PARAMS: string = "&$orderBy=UserName";

 // this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('ZZZ AUDIT TRAIL')/items?${PARAMS}&$top=5000`,
  this.props.context.spHttpClient.get(`https://ssica.sharepoint.com/_api/web/lists/getbytitle('ZZZ AUDIT TRAIL')/items?${PARAMS}&$top=5000`,
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
      response.json().then((responseJSON) => {
        var ctr1 = 0;
        var key0 = '';
        var key0N = '';
        var key0U = '';

        let html = ``;
        html += `<option value='' selected> - Select User - </option>`;
     
        responseJSON.value.map((item: any, index: any) => {
          var key1 = `${item.UserName}`+" "+`${item.UserID}`; 
                  
          if (key1 != key0) {
             if (ctr1 != 0) {
              html += `<option value='${key0U}'>${key0N}</option>`;
             }
             key0 = key1;
             key0N = `${item.UserName}`;
             key0U = `${item.UserID}`;
             ctr1=0;          }

          ctr1++;
        });

        html += `<option value='${key0U}'>${key0N}</option>`;
        document.getElementById("ddANAME").innerHTML = html;
        console.log("ddNAME: \n" + html);
        console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}

// Get all Dates
private getAuditDropDown2 = (): void => {
 
  const PARAMS: string = "&$orderBy=RunDate desc";

 // this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('ZZZ AUDIT TRAIL')/items?${PARAMS}&$top=5000`,
  this.props.context.spHttpClient.get(`https://ssica.sharepoint.com/_api/web/lists/getbytitle('ZZZ AUDIT TRAIL')/items?${PARAMS}&$top=5000`,
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
      response.json().then((responseJSON) => {
        var ctr1 = 0;
        var key0 = '';

        let html = ``;
        html += `<option value='' selected> - Select Date - </option>`;
     
        responseJSON.value.map((item: any, index: any) => {
          var key1 = `${item.RunDate}`; key1 = key1.substring(0,10); 
                  
          if (key1 != key0) {
             if (ctr1 != 0) {
              html += `<option value='${key0}'>${key0}</option>`;
             }
             key0 = key1;
             ctr1=0;
          }

          ctr1++;
        });
        html += `<option value='${key0}'>${key0}</option>`;
        document.getElementById("ddADATE").innerHTML = html;
        console.log("ddDATE: \n" + html);
        console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}

}