import * as React from 'react';
import styles from './Zap000.module.scss';
import { IZap000Props } from './IZap000Props';
import { escape } from '@microsoft/sp-lodash-subset';
import {
  SPHttpClient,
  SPHttpClientResponse
 // HttpClientResponse,
 // ISPHttpClientOptions 
} from '@microsoft/sp-http';

//import { parse } from 'json2csv';
const { parse } = require('json2csv');

export default class Zap000 extends React.Component<IZap000Props, {}> {
  public render(): React.ReactElement<IZap000Props> {
  const {
    //  description
    } = this.props;

  this.checkSecurity();
  this.getDropDown();
 // this.checkAccess();
 // this.getRunAs();

    const IMG1: string = this.props.context.pageContext.web.absoluteUrl+"/SiteAssets/ZAP1.png";
    const IMG2: string = this.props.context.pageContext.web.absoluteUrl+"/SiteAssets/getsitelogo.png";

    return (
      <div className={styles.SpFxCrud}>
        <div className={styles.container}>
          <div id="ADMIN" className={styles.row}>            
           <div className={styles.column}>
           
          <table className={styles.tb1}>
                          
          <tr>
            <td colSpan={8} style={{ textAlign: "right"}} className={styles.description2}> 
               Name: {escape(this.props.context.pageContext.user.displayName)}
               &nbsp; 
               User ID: {escape(this.props.context.pageContext.user.loginName)}
               &nbsp;
               <input type="hidden" id="AdminSec"  className={styles.txhdg}></input>
            </td>
            <td className={styles.spacer}>  &nbsp; </td>
         {/*      <td> Run As: &nbsp;
              <select id="RunAs" className={styles.txone}  onChange={() => this.getZAP2('*')}>
              </select>
            </td>
           
            <td>             
              <select id="Mode" className={styles.txone}>
                <option value='L'>Light</option>
                <option value='D' selected>Dark</option>
                <option value='*'>Compare</option>
              </select>
            </td>
            */}
          </tr>
            
                <tr>
                <td><img src={IMG1} height={50} alt="?"></img>
                </td>
                <td> <p className={styles.description}>{escape(this.props.description)}</p>  </td>
                <td className={styles.spacer}>  &nbsp; </td>

                <td>
                  <div id="btn1" className={styles.tab2}>
                   <span className={styles.label} onClick={() => this.showScreen('1')}>ZAP Portal </span>
                </div>
                </td>

                <td>
                <div id="btn2" className={styles.tab2}>
                   <span className={styles.label} onClick={() => this.showScreen('2')}>ZAP Where Used</span>
                </div>
                </td>
                <td>
                <div id="btn3" className={styles.tab2}>
                   <span className={styles.label} onClick={() => this.showScreen('3')}>Paycom Upload </span>
                </div> 
                </td>
                <td>
                <div id="btn4" className={styles.tab2}>
                   <span className={styles.label} onClick={() => this.showScreen('4')}>Temporary Labor </span>
                </div> 
                </td>
                </tr>

                </table>   
             </div>   
            
          </div>

          <div id="USER" className={styles.row}>            
            <div className={styles.column}>
             
           <table className={styles.tb4}>
                          
          <tr>
            <th colSpan={12} style={{ textAlign: "left"}} className={styles.description}> 
               Name: {escape(this.props.context.pageContext.user.displayName)}
               &nbsp; &nbsp;
               User ID: {escape(this.props.context.pageContext.user.loginName)}
               &nbsp; &nbsp;
               Email ID: {escape(this.props.context.pageContext.user.email)}
               <input type="hidden" id="UserSec"  className={styles.txhdg}></input>
            </th>
          </tr>
            
                <tr>
                <td><img src={IMG2} height={35} alt="?"></img>
                </td>

                <td className={styles.spacer2}>  &nbsp; </td>
                <td colSpan={1}> <p className={styles.label}>ZAP Reporting & Analytics Portal</p>  </td>
                <td className={styles.spacer2}>  &nbsp; </td>
                <td className={styles.spacer2}>  &nbsp; </td>
                <td className={styles.spacer2}>  &nbsp; </td>

                </tr>

                </table>   
             </div>   
            
          </div>


          <div className={styles.row}>         
            <div className={styles.column}>

          <div id="Div001" className={styles.Div001}>
          <div className={styles.div1}> 

              <p><table id="NavBar" className={styles.tb3}>
                <tr>
                  <td>
                  <div id="btnNav0" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('0')}>
                  <input type="text" size={25} id="descNav0" value='All Reports' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>

                  <div id="btnNav1" className={styles.tab3x}>
                  <span className={styles.label} onClick={() => this.getZAP2('1')}>
                  <input type="text" size={25} id="descNav1" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>

                  <div id="btnNav2" className={styles.tab3x}>
                  <span className={styles.label} onClick={() => this.getZAP2('2')}>
                  <input type="text" size={25}  id="descNav2" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>

                  <div id="btnNav3" className={styles.tab3x}>
                  <span className={styles.label} onClick={() => this.getZAP2('3')}>
                  <input type="text" size={25}  id="descNav3" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>

                  <br></br>
                  
                  <div id="btnNav4" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('4')}>
                  <input type="text" size={25}  id="descNav4" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                   
                  <div id="btnNav5" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('5')}>
                  <input type="text" size={25}  id="descNav5" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                   
                  <div id="btnNav6" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('6')}>
                  <input type="text" size={25}  id="descNav6" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                   
                  <div id="btnNav7" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('7')}>
                  <input type="text" size={25}  id="descNav7" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                   
                  <div id="btnNav8" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('8')}>
                  <input type="text" size={25}  id="descNav8" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                   
                  <div id="btnNav9" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('9')}>
                  <input type="text" size={25}  id="descNav9" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                    
                  <div id="btnNav10" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('10')}>
                  <input type="text" size={25}  id="descNav10" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                                     
                  <div id="btnNav11" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('11')}>
                  <input type="text" size={25}  id="descNav11" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                                     
                  <div id="btnNav12" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('12')}>
                  <input type="text" size={25}  id="descNav12" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                                     
                  <div id="btnNav13" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('13')}>
                  <input type="text" size={25}  id="descNav13" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                                     
                  <div id="btnNav14" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('14')}>
                  <input type="text" size={25}  id="descNav14" value='' className={styles.txtab}></input>
                  </span>
                  </div> 
                  <br></br>
                                                     
                  <div id="btnNav15" className={styles.tab3}>
                  <span className={styles.label} onClick={() => this.getZAP2('15')}>
                  <input type="text" size={25}  id="descNav15" value='' className={styles.txtab}></input>
                  </span>
                  </div>  
                  <br></br>        
              </td>

              <td>
              <div id="allItems2" className={styles.tb3}></div> 
              </td>
              </tr>
              </table>
              </p>
              </div>
                        
          </div>  {/*  END OF Div001 */}


          <div id="Div002" className={styles.Div002}>
              <div className={styles.div1}>
                  <b>ZAP: &nbsp; </b>     
                  <input type="hidden" size={5} id="inZAP" className={styles.txtwo} value=""></input>
                  <select id="inFLD0"  className={styles.txtwo}>
                  <option value="%" selected>ALL</option>
                  <option value="Production">Production</option>
                  <option value="Development">Development</option>
                  <option value="AX Analytics">AX Analytics</option>
                  <option value="Common">Common</option>
                  <option value="%Supporting%">Supporting</option>
                  </select> 
                  &nbsp;
                  <b> REPORT:</b>
                  &nbsp;
                  <input type="text" size={20} id="inFLD3" className={styles.txtwo} placeholder='Report Name%'></input>   
                  
                   &nbsp;
                  <input type="text" size={30} id="inFLD1" className={styles.txtwo} placeholder='%Search Key%'></input>   
                  &nbsp;
                  <input type="text" size={15} id="inFLD2" className={styles.txtwo} placeholder='%Search Key%'></input>
                 
              <p>
                
                {/*  <button id="btnZAP" value="27" className={styles.button} onClick={this.getApi}>Search</button> */}  
                  <span id="btnZAP" className={styles.button} onClick={this.getApi}> Search </span>  
                  
                  <div  className={styles.button2}>
                  <span className={styles.label} onClick={() => this.showScreen('2')}>Refresh </span>
                  </div> 
                  <div className={styles.button2}>
                  <span className={styles.label} onClick={this.csvDownload}>Download</span> 
                  </div>
                  <input type="checkbox" id="inZLIST"></input>Report Listing 
              </p>
              </div>   
          </div> {/*  END OF Div002 */}
   

          <div id="Div003" className={styles.Div003}>
                <div className={styles.div1}> 
                <p>Sharepoint Upload No longer used. &nbsp; &nbsp; Please use the network drive process. &nbsp;
                </p>
                <p>Download Documentation: &nbsp; <a href="https://ssica.sharepoint.com/:w:/r/sites/ZAP-BI-Portal/Shared%20Documents/ZAP%20-%20Paycom%20and%20Labort%20Uploads.docx?d=w4cdecd17ba9a4a01aecba061b15caedc&csf=1&web=1&e=vn1mVN" target="_blank">Turlock ZAP Network Drive </a>
                </p>
                </div>
          </div> {/*  END OF Div003 */}
         
          <div id="Div004" className={styles.Div004}>
                <div className={styles.div1}> 
                <p>Sharepoint Upload No longer used. &nbsp; &nbsp; Please use the network drive process. &nbsp;
                </p>
                <p>Download Documentation: &nbsp; <a href="https://ssica.sharepoint.com/:w:/r/sites/ZAP-BI-Portal/Shared%20Documents/ZAP%20-%20Paycom%20and%20Labort%20Uploads.docx?d=w4cdecd17ba9a4a01aecba061b15caedc&csf=1&web=1&e=vn1mVN" target="_blank">Turlock ZAP Network Drive </a>
                </p>
                </div>
          </div> {/*  END OF Div004 */}
        
          <div id="Div005" className={styles.Div005}>  
              
          </div>  {/*  END OF Div005 */}

          <div id="Div006" className={styles.Div006}>
              
          </div>   {/*  END OF Div006 */}
         
          <div id="Div007" className={styles.Div007}>
                            
          </div>   {/*  END OF Div007 */}


         </div>
         </div>

            <div className={styles.row}>          
               <div className={styles.column}>
          
                  <div><input type="text" id='MSG1' size={77} disabled className={styles.MSG1} value=""></input>
                  <p></p>
                  </div>
              
                  <div id="allItems" className={styles.tb2}></div>  
            
               </div>
            </div>
         
        </div>
      </div>

    );


  }

  componentDidMount(){
    
    this.checkSecurity();
  //  this.checkAccess();
    this.showScreen('');

  }

//----------------------------------------------------------------------------  
// Show/Hide Menus and Screens.
//---------------------------------------------------------------------------- 
private showScreen = (n: any): void => { 
  // alert('N: ' + n)
   if (n == '') {  // Initial Screen - First Time In  
    //alert("FTI");
    this.getZAP2('');
    document.getElementById("btn1").style.color="#000000";
    document.getElementById("btn1").style.backgroundColor="#CFC3FF";
    (document.getElementById("MSG1")  as HTMLInputElement).hidden = true; 
    (document.getElementById("MSG1")  as HTMLInputElement).value = `ZAP Reporting & Analytics Portal`; 
    return;
    }
   // Hide all Screens
   var nbr_of_divs = 5;  // Total plus 1
   var i = 0;
   for (i = 1; i < nbr_of_divs; i++) { 
       var DIV1 = "Div00"+i;
       var BTN1 = "btn"+i;
     //  alert('I: ' + i + ' ' + DIV1 + ' ' + BTN1)
       var e1 = (document.getElementById(DIV1));  e1.style.display  = 'none';
       document.getElementById(BTN1).style.color="#333333";
       document.getElementById(BTN1).style.backgroundColor="#fffffa";
   };
 
   // Set active screen visible
   var DIV1 = "Div00"+n;
   var BTN1 = "btn"+n;
   //alert('N: ' + i + ' ' + DIV1 + ' ' + BTN1)
   var e1 = (document.getElementById(DIV1));  e1.style.display  = 'block';
   document.getElementById(BTN1).style.color="#000000";
   document.getElementById(BTN1).style.backgroundColor="#CFC3FF";
  // document.getElementById(BTN1).style.backgroundColor="#AD9DDF";


   // Reset defaults
   (document.getElementById("btnZAP")  as HTMLInputElement).removeAttribute("disabled");
   document.getElementById("allItems").innerHTML = "";

   var MSG1 = [];
   MSG1[1] = `ZAP Reporting & Analytics Portal`; 
   MSG1[2] = `Enter search criteria and search ZAP Where Used Information`; 
   MSG1[3] = `*** NO LONGER ACTIVE ***`; 
   MSG1[4] = `*** NO LONGER ACTIVE ***`;
   MSG1[5] = ``;  
   MSG1[6] = ``; 
   MSG1[7] = ``; 
  
   var MESSAGE = MSG1[n];
   (document.getElementById("MSG1")  as HTMLInputElement).hidden = false; 
   (document.getElementById("MSG1")  as HTMLInputElement).value = `${MESSAGE}`; 
   
   if (n == '2') { 
      (document.getElementById("inFLD0") as HTMLSelectElement).selectedIndex = 0;
      (document.getElementById("inZAP")  as HTMLInputElement).value = `27`; 
      (document.getElementById("inFLD1")  as HTMLInputElement).value = ``; 
      (document.getElementById("inFLD2")  as HTMLInputElement).value = ``; 
      (document.getElementById("inFLD3")  as HTMLInputElement).value = ``; 
      (document.getElementById("USER")  as HTMLInputElement).style.display = 'none';
      }
   else { 
      (document.getElementById("inZAP")  as HTMLInputElement).value = ``; 
   }
    
   if (n == '1') {  
    this.getZAP2('0');
    (document.getElementById("MSG1")  as HTMLInputElement).hidden = true; 
    document.getElementById("allItems").innerHTML = "";
   // (document.getElementById("ADMIN")  as HTMLInputElement).style.display = 'none';
   (document.getElementById("USER")  as HTMLInputElement).style.display = 'block';
    }
 
    if (n == '3') {  
      //this.getUploadReport();
      (document.getElementById("btnUpload1")  as HTMLInputElement).style.display = 'none'; 
      (document.getElementById("btnUpload2")  as HTMLInputElement).style.display = 'none'; 
      (document.getElementById("USER")  as HTMLInputElement).style.display = 'none';
      }
    

    if (n == '4') {  
      //this.getUploadReport2();
      (document.getElementById("btnUpload3")  as HTMLInputElement).style.display = 'none'; 
      (document.getElementById("btnUpload4")  as HTMLInputElement).style.display = 'none'; 
      (document.getElementById("USER")  as HTMLInputElement).style.display = 'none';
      this.getDropDown();
      }

    }


private csvDownload = (): void => {
      // alert("Download");

         let csv2 = localStorage.getItem("key")

         var hiddenElement = document.createElement('a');  
         hiddenElement.href = 'data:text/csv;charset=utf-8,' + encodeURI(csv2);  
         hiddenElement.target = '_blank';  

         //provide the name for the CSV file to be downloaded  
         hiddenElement.download = 'JSON CSV.csv';  
         hiddenElement.click();  
      
}

/*
private getUserProfile = (x: any): void => {
  //alert("HELLO")
  if (x != 1) {
     var UID = (document.getElementById("UID1")  as HTMLInputElement).value;
  }
  var GET = `GetMyProperties`;
  
  if (UID != '')
  {
    //encodeURIComponent()
     GET = `GetPropertiesFor(accountName=@v)?@v='i:0%23.f|membership|${UID}'`;
 //    GET = `GetPropertiesFor(accountName=@v)?@v='i:0%23.f|membership|bwmmis1@ssica.com'`;
  }

//  alert("WHOM: " +GET);

//this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties`,

this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/${GET}`,


//   this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties?$select=Email`,
//   this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties?$select=DisplayName`,
//   this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties?$select=Department`,
// For Office 365/SharePoint Online:
// http://siteurl/_api/SP.UserProfiles.PeopleManager/GetPropertiesFor(accountName=@v)?@v=’i:0%23.f|membership|vardhaman@siteurl.onmicrosoft.com’

 SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
   // alert("Return")
  return response.json();

  })
  .then((data: any) => {
   //  alert("Your Department is: " + data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value);
  // alert(data.DisplayName);
  // alert(data.Email);

  
  var results = data.UserProfileProperties;

  var html = `<table>`;
  var i=0;
  for (i = 0; i < results.length; i++) { 
      html += `<tr><td> ${results[i].Key}</td><td> ${results[i].Value} </td></tr>`;

   };
     // alert("DEPT:" + data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value);
  // var myDept = data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value;
  // alert("DEPT:" + myDept)
  // if (UID == '') { document.getElementById("DeptInfo").innerHTML = myDept; }

  html += `</table>`;
  document.getElementById("allItems").innerHTML = html;
  //alert('HTML:' + html);
   
   return data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value;
  //alert(data.DisplayName);
  //alert(data.Email);

  //alert("PHON:" + data.UserProfileProperties.find((p: any) => p.Key === 'WorkPhone').Value);
  //alert("ACCT:" + data.UserProfileProperties.find((p: any) => p.Key === 'AccountName').Value);
  //alert("SPSD:" + data.UserProfileProperties.find((p: any) => p.Key === 'SPS-Department').Value);
  })
  .catch((err: any) => {
    //alert("ERR")
    var html = `<p>${UID} Not Found:`;
    document.getElementById("allItems").innerHTML = html;

  console.log(err);
  });
  //</User, Department>
}
*/



private getApi = (): void => {

  (document.getElementById("btnZAP")  as HTMLInputElement).setAttribute("disabled", "disabled");

  var inFLD0 = (document.getElementById("inFLD0")  as HTMLInputElement).value;
  var inFLD1 = (document.getElementById("inFLD1")  as HTMLInputElement).value;
  var inFLD2 = (document.getElementById("inFLD2")  as HTMLInputElement).value;
  var inFLD3 = (document.getElementById("inFLD3")  as HTMLInputElement).value;
  var inParms = '';

  var inZAP = (document.getElementById("inZAP")  as HTMLInputElement).value;
  if (inZAP == '27') {
    var inAPI  = '27';
    inFLD1 = inFLD1.trim();
    inFLD1 = inFLD1.replace(/\*/g, "%"); // allow "*" as wild-card
    inFLD2 = inFLD2.trim();
    inFLD2 = inFLD2.replace(/\*/g, "%"); // allow "*" as wild-card
    inFLD3 = inFLD3.trim();
    inFLD3 = inFLD3.replace(/\*/g, "%"); // allow "*" as wild-card
    let CHK0 = (document.getElementById('inZLIST')  as HTMLInputElement).checked;
    if (CHK0 == true) { inAPI = '28'; }
    if (inFLD1 == '' && inFLD2 == '' && inFLD3 == '' && CHK0 == false) {
      (document.getElementById("MSG1")  as HTMLInputElement).value = `Please enter a Search Key.`; 
      (document.getElementById("btnZAP")  as HTMLInputElement).removeAttribute("disabled");
      return;
    }
    inFLD1 = '%'+inFLD1+'%';
    inFLD2 = '%'+inFLD2+'%';
    inFLD3 = inFLD3+'%';
    inParms  = '&in0='+inFLD0+'&in1='+inFLD1+'&in2='+inFLD2+'&in3='+inFLD3;
  }
  console.log('PARMS:' + inAPI + ' ' + inParms);
  //alert("BOB:" + inAPI + ' ' + inParms);

 this.props.context.spHttpClient.get(`https://ssi-node-api-001.azurewebsites.net/app001?&rpt=${inAPI}${inParms}`,
 SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    
    (document.getElementById("btnZAP")  as HTMLInputElement).removeAttribute("disabled");

    if (response.ok) {
      response.json().then((responseJSON) => {
        var ctr1 = 0;
        var csv1 = '';
        let html = `<table><tr><th colspan=5>MySQL API Call</th></tr>`;
   
      if (inAPI == '27' || inAPI == '28') { 
        html += "<tr>";
        html += "<td>REPORT/MODULE";
        html += "<td>MEASURE";
        html += "<td>PATH";      
      }

        if (responseJSON.length == 0) { 
         // alert("EMPTY");
          document.getElementById("allItems").innerHTML = "No Data Found.";
          return;
        }

        var csv2 = parse(responseJSON);

        if (inAPI == '4' || inAPI == '3') { 
           var call1 = responseJSON[0].length;
         // alert("CALL:" + call1);
           responseJSON.length = call1;
           var csv2 = parse(responseJSON[0]);
        //   var tempx1 = responseJSON[0];
        //   var csv2 = parse(tempx1);
           csv2 = csv2.replace(/#/g, "~");
           }
        var i=0;
        for (i = 0; i < responseJSON.length; i++) { 

          if (inAPI == '1') { 
            html += "<tr>";
            html += "<td>"+responseJSON[i].HHICUSN;
            html += "<td>"+responseJSON[i].HHIORNR;
            html += "<td>"+responseJSON[i].HHILNOI;
            html += "<td>"+responseJSON[i].dateof_lastorder;
            html += "<td>"+responseJSON[i].HHIITMN;
            html += "<td>"+responseJSON[i].HHIWHSN;
            html += "<td>"+responseJSON[i].HHIQYSA;        
          }
          if (inAPI == '2') { 
            html += "<tr>";
          //    html += `<td><button onClick={[testLink1()]}>alert</button>`;
          //  html += `<td> <a href="#" onClick={()=>onClick={this.testLink1('hello')}}>Click here</a>`;
       
            html += "<td>"+responseJSON[i].fy;
            html += "<td>"+responseJSON[i].pd;
            html += "<td>"+responseJSON[i].beg1;
            html += "<td>"+responseJSON[i].end1;

            csv1 += responseJSON[i].fy + (',');  
            csv1 += responseJSON[i].pd + (',');  
            csv1 += responseJSON[i].beg1 +(',');  
            csv1 += responseJSON[i].end1 +(',');  
            csv1 += "\n";  
          }
          if (inAPI == '3') { 
            html += "<tr><td>Banner </td><td>"+responseJSON[0][0].banner;
            html += "<tr><td>Customer </td><td>"+responseJSON[0][0].ffdcusn;
            html += "<tr><td>Code </td><td>"+responseJSON[0][0].ffdshcd;
            html += "<tr><td>Name </td><td>"+responseJSON[0][0].ffdcnmb;
            html += "<tr><td>ADDR1 </td><td>"+responseJSON[0][0].ffdcc1b;
            html += "<tr><td>ADDR2 </td><td>"+responseJSON[0][0].ffdcc2b;
            html += "<tr><td>CITY </td><td>"+responseJSON[0][0].ffdctyb;
            html += "<tr><td>ST </td><td>"+responseJSON[0][0].ffdsteb;
            html += "<tr><td>ZIP </td><td>"+responseJSON[0][0].ffdzpcb;
            html += "<tr><td>Phone </td><td>"+responseJSON[0][0].ffdphnb;        
          }
          if (inAPI == '4') { 
            html += "<tr><td>"+responseJSON[0][i].process;
            html += "<td>"+responseJSON[0][i].description;
            html += "<td>"+responseJSON[0][i].ship_date;
            html += "<td>"+responseJSON[0][i].create_datetime;
            html += "<td>"+responseJSON[0][i].recid;
            html += "<td>"+responseJSON[0][i].pdt;    
          }
          if (inAPI == '27' || inAPI == '28') { 
            html += "<tr><td>"+responseJSON[i].rpt1; 
            html += "<td>"+responseJSON[i].desc1;
            html += "<td>"+responseJSON[i].key2;
            html += "<td>"+responseJSON[i].key1;
          }
          

             ctr1++;
          };

        html += `<tr><td colSpan=5>Number of Records: &nbsp; ${ctr1} </td><tr>`;
        html += `</table>`;
        document.getElementById("allItems").innerHTML = html;
      //  alert('HTML:' + html);

      
     // let CHK0 = (document.getElementById('inCSV')  as HTMLInputElement).checked;
     // if (inAPI == '2' && CHK0 == true) { 
     if (inAPI == '2') { 
        // let csvContent = "data:text/csv;charset=utf-8,"  + csv1;
        // var encodedUri = encodeURI(csvContent);
        // window.open(encodedUri);
         var hiddenElement = document.createElement('a');  
         hiddenElement.href = 'data:text/csv;charset=utf-8,' + encodeURI(csv1);  
         hiddenElement.target = '_blank';  
           
                  //provide the name for the CSV file to be downloaded  
         hiddenElement.download = 'My Download File.csv';  
         hiddenElement.click();  
/*
         var hiddenElement = document.createElement('a');  
         hiddenElement.href = 'data:text/csv;charset=utf-8,' + encodeURI(csv2);  
         hiddenElement.target = '_blank';  
           
         //provide the name for the CSV file to be downloaded  
         hiddenElement.download = 'JSON CSV.csv';  
         hiddenElement.click();  
         */
      }
    
       localStorage.setItem("key", csv2);

        console.log(responseJSON);
      });
    } else {
      alert(`Status code: ${response.status} ${response.statusText}`);
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}

/*
private fetch1  = (): void => {
 // alert("FETCH")
  var inAPI = (document.getElementById("inAPI")  as HTMLInputElement).value;
  var inFY = (document.getElementById("inFYPD")  as HTMLInputElement).value;
  var inDT = (document.getElementById("inDT")  as HTMLInputElement).value;

 // body: JSON.stringify(`{ rpt: '2', in0: '2023' }`)
  //  body: `{ rpt: '2', in0: '${inFY}' }`

fetch('https://ssi-node-api-001.azurewebsites.net/app002',{
  method: 'POST',
  body: JSON.stringify({ rpt: inAPI, in0: inFY, in1: inDT }),
  headers: {"Content-Type": "application/json"}
})
.then(function(response){
  if (response.ok) {
 // alert("Response")
  response.json().then((responseJSON) => {
    var ctr1 = 0;
    let html = `<table><tr><th colspan=5>MySQL API Call</th></tr>`;
      
    if (inAPI == '1') { 
      html += "<tr>";
      html += "<td>HHICUSN";
      html += "<td>HHIORNR";
      html += "<td>HHILNOI";
      html += "<td>dateof_lastorder";
      html += "<td>HHIITMN";
      html += "<td>HHIWHSN";
      html += "<td>HHIQYSA";        
    }
    if (inAPI == '2') { 
      html += "<tr>";
      html += "<td>Fiscal Year";
      html += "<td>Period";
      html += "<td>Beg Date";
      html += "<td>End Date";
    }
    if (responseJSON.length == 0) { 
      //  alert("EMPTY");
        document.getElementById("allItems").innerHTML = "No Data Found.";
        return;
      } 
  //  var data=responseJSON;
  //  var data1 = (data[2].pd);
  //  console.log('DATA-REF:' + data1);
  //  alert("HI:" + data)

      if (responseJSON.length == 0) { 
        // alert("EMPTY");
         document.getElementById("allItems").innerHTML = "No Data Found.";
         return;
       }
 
       if (inAPI == '4' || inAPI == '3') { 
         var call1 = responseJSON[0].length;
        // alert("CALL:" + call1);
         responseJSON.length = call1;
          }

       var i=0;
       for (i = 0; i < responseJSON.length; i++) { 

         if (inAPI == '1') { 
           html += "<tr>";
           html += "<td>"+responseJSON[i].HHICUSN;
           html += "<td>"+responseJSON[i].HHIORNR;
           html += "<td>"+responseJSON[i].HHILNOI;
           html += "<td>"+responseJSON[i].dateof_lastorder;
           html += "<td>"+responseJSON[i].HHIITMN;
           html += "<td>"+responseJSON[i].HHIWHSN;
           html += "<td>"+responseJSON[i].HHIQYSA;        
         }
         if (inAPI == '2') { 
           html += "<tr>";
           html += "<td>"+responseJSON[i].fy;
           html += "<td>"+responseJSON[i].pd;
           html += "<td>"+responseJSON[i].beg1;
           html += "<td>"+responseJSON[i].end1;
         }
         if (inAPI == '3') { 
           html += "<tr><td>Banner </td><td>"+responseJSON[0][0].banner;
           html += "<tr><td>Customer </td><td>"+responseJSON[0][0].ffdcusn;
           html += "<tr><td>Code </td><td>"+responseJSON[0][0].ffdshcd;
           html += "<tr><td>Name </td><td>"+responseJSON[0][0].ffdcnmb;
           html += "<tr><td>ADDR1 </td><td>"+responseJSON[0][0].ffdcc1b;
           html += "<tr><td>ADDR2 </td><td>"+responseJSON[0][0].ffdcc2b;
           html += "<tr><td>CITY </td><td>"+responseJSON[0][0].ffdctyb;
           html += "<tr><td>ST </td><td>"+responseJSON[0][0].ffdsteb;
           html += "<tr><td>ZIP </td><td>"+responseJSON[0][0].ffdzpcb;
           html += "<tr><td>Phone </td><td>"+responseJSON[0][0].ffdphnb;        
         }
         if (inAPI == '4') { 
           html += "<tr><td>"+responseJSON[0][i].process;
           html += "<td>"+responseJSON[0][i].description;
           html += "<td>"+responseJSON[0][i].ship_date;
           html += "<td>"+responseJSON[0][i].create_datetime;
           html += "<td>"+responseJSON[0][i].recid;
           html += "<td>"+responseJSON[0][i].pdt;    
         }
         ctr1++;
      };

    html += `<tr><td colSpan=2>Number of Records:</td><td> ${ctr1} </td><tr>`;
    html += `</table>`;
    document.getElementById("allItems").innerHTML = html;
  //  alert('HTML:' + html);
    console.log(responseJSON);
  });
}
  else {
    alert(`Status code: ${response.status}` +  `${response.statusText}`);
  }
  return;
  //return response.json()

}).then(function(body){
  console.log(body);
 // alert("BODY:" + body);
});
}
*/




// Check for Admin Access
private checkSecurity = (): void => {
  var USER = this.props.context.pageContext.user.loginName;
 // USER = 'dmmis1@ssica.com';
  var PARAMS = `&$filter=Title eq '${USER}'`;
 // alert("ADMIN:" + PARAMS);
  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('ZAP Security Access')/items?${PARAMS}&$orderBy=Title&$top=999`,
 //  this.props.context.spHttpClient.get(`https://ssica.sharepoint.com/ZAP-BI-Portal/_api/web/lists/getbytitle('ZAP Security Access')/items?${PARAMS}&$orderBy=field_2,field_1,Title&$top=999`,
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
      
 /*     var len1 = response.json.length;
      alert('LEN1:' + len1);
      if (len1 == 0) { 
        //alert("EMPTY");
        (document.getElementById("ADMIN")  as HTMLInputElement).style.display = 'none';
        return;
     }
     */
     // alert('OK:');
      response.json().then((responseJSON) => {
      //  let html = ``;
        var name1 = '';
        var access1 = '';

        responseJSON.value.map((item: any, index: any) => {
          name1  = `${item.Name}`;
          access1 = `${item.AccessLevel}`;

          //alert("WHO:" + name1 + ' ' + access1);
        });
        var namex = name1 + access1;
        (document.getElementById("AdminSec")  as HTMLInputElement).value = `${access1}`; 
        (document.getElementById("MSG1")  as HTMLInputElement).value = `${namex}`; 
        
        if (access1 == '') {
           //alert("No Admin");
           (document.getElementById("ADMIN")  as HTMLInputElement).style.display = 'none';
        }
                
        if (access1 == 'UPLOADS') {
          // alert("upload");
          (document.getElementById("btn2")  as HTMLInputElement).style.display = 'none';
        }

   // alert('HTML:' + html);
      console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}

/*
// Check for Security Roles
private checkAccess = (): void => {
  var USER = this.props.context.pageContext.user.email;
  var PARAMS = `&$filter=Title eq '${USER}'`;
 // alert("ADMIN:" + PARAMS);
  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('ZAP Security Roles')/items?${PARAMS}&$orderBy=Title&$top=999`,
 //  this.props.context.spHttpClient.get(`https://ssica.sharepoint.com/ZAP-BI-Portal/_api/web/lists/getbytitle('ZAP Security Roles')/items?${PARAMS}&$orderBy=field_2,field_1,Title&$top=999`,
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
      response.json().then((responseJSON) => {
      //  let html = ``;
        var name1 = '';
        var access1 = '';
        responseJSON.value.map((item: any, index: any) => {
          name1  = `${item.Name}`;
          access1 = `${item.SecurityLevel}`;

         // alert("WHO:" + name1 + ' ' + access1);
        });
        var namex = name1 + access1;
        (document.getElementById("UserSec")  as HTMLInputElement).value = `${access1}`; 
        (document.getElementById("MSG1")  as HTMLInputElement).value = `${namex}`; 
    
   // alert('HTML:' + html);
      console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}
*/

/*
// Cet list of Users for "Run As" function
private getRunAs = (): void => {
  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('ZAP Security Roles')/items?&$orderBy=Title&$top=999`,
 //  this.props.context.spHttpClient.get(`https://ssica.sharepoint.com/ZAP-BI-Portal/_api/web/lists/getbytitle('ZAP Security Roles')/items?&$orderBy=field_2,field_1,Title&$top=999`,
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
      response.json().then((responseJSON) => {
        let html = `<option value='5'></option>`;
        var name1 = '';
        var level1 = '';
       // var email1 = '';
        responseJSON.value.map((item: any, index: any) => {
          name1  = `${item.Name}`;
         // email1 = `${item.Title}`;
          level1 = `${item.SecurityLevel}`;
          html += `<option value='${level1}'>${name1}</option>`;
        });

        document.getElementById("RunAs").innerHTML = html; 

        // Only show for me
        var userid = this.props.context.pageContext.user.email;
        if (userid != 'bmcnulty@ssica.com') {
          document.getElementById("RunAs").style.display = 'none'; 
        }
        
    
   // alert('HTML:' + html);
      console.log('HTML:\n' + html);
      console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}
*/

// Get List of ZAP Reports
private getZAP2 = (n: any): void => {
 /*  var RunAs = ''; 
   if (n == '*') {
     let e = (document.getElementById("RunAs") as HTMLSelectElement);
     RunAs = e.options[e.selectedIndex].value;
     //alert("RUNAS: " + RunAs);
     n = '';
     (document.getElementById("ADMIN")  as HTMLInputElement).style.display = 'none';
   }
   */

   //alert("GETZAP")
   if (n == '') { n = 0; }
   var PARAMS = `&$filter=field_2 eq '${n}'`;
   if (n == '0') { PARAMS = ''; }
   //alert("GETZAP2: " + PARAMS)

   // Reset tab background colors
  let ix = 0; 
  for (ix = 0; ix < 16; ix++) { 
    //alert("IX:" + ix);
    document.getElementById("btnNav"+ix).style.backgroundColor="#FFFFFF";
 //   document.getElementById("btnNav"+ix).style.border="none";     
  }; 

//  document.getElementById("btnNav0").style.border="solid 2px #CFC3FF"; 
  document.getElementById("btnNav"+n).style.backgroundColor="#CFC3FF";

  //  document.getElementById("btnNav0").className='tab2';
  //document.getElementById("btnNav"+n).className="tab3";

     this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('ZAP Reports')/items?${PARAMS}&$orderBy=field_2,field_1,Title&$top=999`,
    //this.props.context.spHttpClient.get(`https://ssica.sharepoint.com/ZAP-BI-Portal/_api/web/lists/getbytitle('ZAP Reports')/items?${PARAMS}&$orderBy=field_2,field_1,Title&$top=999`,
   SPHttpClient.configurations.v1,
   {
     headers: {
       'Accept': 'application/json;odata=nometadata',
       'odata-version': ''
     }
   })
   .then((response: SPHttpClientResponse) => {
     if (response.ok) {
      response.json().then((responseJSON) => {
        var ctr1 = 0;
        var nbr_of_groups = 0;
        var key0 = '';
        var grp0 = '';
       
        // Set up array for which groups are active (security check)
        var grpUsed = ['Y','','','','','','','','','','','','','','',''];
       
       // var access1 =  (document.getElementById("UserSec")  as HTMLInputElement).value;
       // if (RunAs != '') { access1 = RunAs; }

        //alert("ACCESS:" + access1);
    //  let html = `<div style="border:solid;border-width:2px;border-radius:7px;width:425px;float:left;"><ul style="list-style-type:none;width:385px;">`;
        let html = `<div>`;
      // let html = `<table border=1 width=300>`;
    
        responseJSON.value.map((item: any, index: any) => {
          var key1 = `${item.field_1}`;
          var grp1 = `${item.field_2}`;
        //  var lvl1 = `${item.SecurityLevel}`;       

        ////  if (access1 >= lvl1) {
             if (grp1 != grp0) {
              //alert('New Group: ' +  key1 + ' ' + grp1);
              (document.getElementById("descNav"+grp1) as HTMLInputElement).value =  `${item.field_1}`;
              if (grp1 > '4') {
                 document.getElementById("btnNav"+grp1).style.border = "solid 2px #CFC3FF"; 
              }
              nbr_of_groups++;
              var ix1 = Number(grp1);
              grpUsed[ix1] = 'Y';
              }
       
          if (key1 != key0) {
               html += ` <div style="border:none;border-width:1px;width:800px;float:left;padding:5px;margin:1px;"><b><font color=#222266 size=+0>${item.field_1}</font></b></div>`;        
          }

          // default height + dashboard overrides
          var ht1 = '45';
          if (grp1 == '2') { ht1 = '110';}
          if (grp1 == '7') { ht1 = '110';}
          if (grp1 == '8') { ht1 = '110';}
         
          var desc1 = `${item.field_4}`;
          var descx = '';
          var href1 = `<a href="${item.field_3}" target="_blank" style="text-decoration:none"><font color="CFC3FF">`;
          var hend1 = `</font></a>`;
         
          if (desc1 != "null") { descx = "<br><font size=-1>"+`${item.field_4}`+"</font></br>"; }
          

    /*
          var mode = (document.getElementById("Mode") as HTMLInputElement).value;
          if (mode == 'L' || mode == '*') {
             html += `${href1}`;  // make entire div clickable       
             html += `<div style="border:double;border-width:3px;border-radius:7px;width:400px;height:${ht1}px;float:left;margin:3px;background-color:#FBFAFF;"><ul style="list-style-type:none;width:355px;">`;         
             html += `<li style="margin-bottom:6px;"><font color="#222299"><b>${item.Title}</b> </font><font color="#333399">${descx}</font></li>`;
             html += `</div>${hend1}`;  
          }
     */            
     //     if (mode == 'D' || mode == '*') {
             html += `${href1}`;  // make entire div clickable  
             html += `<div style="border:double;border-width:3px;border-radius:7px;width:400px;height:${ht1}px;float:left;margin:3px;background-color:#6C67BE;"><ul style="list-style-type:none;width:355px;">`;                  
             html += `<li style="margin-bottom:6px;"><font color="white"><b>${item.Title}</b> </font><font color="#eeeeee">${descx}</font></li>`;
             html += `</div>${hend1}` 
     //     }
     
          key0 = key1;
          grp0 = grp1;
             
          ctr1++;
    ////      }
            
        });
   
        html += `</ul></div>`;
        document.getElementById("allItems2").innerHTML = html;
        document.getElementById("allItems").innerHTML = '';
        (document.getElementById("MSG1")  as HTMLInputElement).hidden = true; 

       // this.render();

      
        if (n == 0) { // If first time in hide unused tabs
           let ix = 0; 
           //alert('BLANK:' + nbr_of_groups + '\n' + grpUsed)
           for (ix = ix + 1; ix < 16; ix++) { 
            if (grpUsed[ix] != 'Y') {
    //         document.getElementById("btnNav"+ix).style.backgroundColor="#FFFFFF";
    //         document.getElementById("btnNav"+ix).style.border="none";  
               document.getElementById("btnNav"+ix).style.display = 'none'; 
    //         (document.getElementById("btnNav"+ix)  as HTMLInputElement).innerHTML = '';    
            }
           }; 
        }

        if (ctr1 == 0) {
          this.getHelpList();
        }
        console.log('HTML: \n' + html);
        console.log(' Nbr of Groups: ' + nbr_of_groups + '\n Nbr of Reports: ' + ctr1);
      
      
     // alert('HTML:' + html);
        console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}

// Check for Admin Access
private getHelpList = (): void => {
   this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('ZAP Contact List')/items?&$orderBy=ID&$top=999`,
 //  this.props.context.spHttpClient.get(`https://ssica.sharepoint.com/ZAP-BI-Portal/_api/web/lists/getbytitle('ZAP Contact List')/items?&$orderBy=ID,Title&$top=999`,
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
      response.json().then((responseJSON) => {
        let html = '';
        let table1 = `<table><tr><th colspan=3 style="text-align:center;"><b> For access to ZAP BI Reports contact: </b><hr></tr>`;

        responseJSON.value.map((item: any, index: any) => {
          table1 += `<tr><td>${item.Title}</td><td>${item.Email}</td><td>${item.Phone}</td></tr>`;
        });

        table1 += `</table>`;
        html = `<div style="border:double;border-width:3px;border-radius:7px;width:400px;float:left;padding-left:50px;margin-left:50px;background-color:#FBFAFF;text-align:center;">`;
        html += `<p>${table1}</p></div>`;
        document.getElementById("allItems").innerHTML = html;
        document.getElementById("NavBar").style.display = 'none'; 
        (document.getElementById("MSG1")  as HTMLInputElement).hidden = false; 
        (document.getElementById("MSG1")  as HTMLInputElement).value = `You do not have access to any ZAP Reports.`; 

   // alert('HTML:' + html);
      console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}

/*
// Get File to Upload
private getUploadFile = (): void => {

  let html = "<table>";
  html += `<tr><th>Row </th><th>EE Code </th><th>Last Name </th><th>First Name </th><th>Pay Class </th><th>Department </th><th>Hours Only </th><th>Earn Hours </th><th>Differential </th><th>Diff Earn </th>`;
  let file = (document.getElementById("readfile") as HTMLInputElement).files[0];
  const fileReader = new FileReader();
  fileReader.onload = event => {
    const fileText: any = event.target.result;
   // alert("FILE:" + fileText)
    const lines = fileText.split('\n');
   // const len1 = lines.length;
   // alert("line0:" + lines[0] + "LEN:" + len1 )

   var ctr1 = 0;
   let file1 = (document.getElementById("readfile") as HTMLInputElement).value;
   let pos1 = file1.lastIndexOf("\\");
   //alert ("POS: " + pos1)
  
   var pos2 = file1.lastIndexOf(".");
   var FileSuffix = file1.substring(pos2+1,pos2+4);
   
   var FileName = file1.substring(pos1+1,pos2);
   //alert ("FILENAME:" + FileName + '\n' + FileSuffix);

   if (FileSuffix != "txt") {
      alert("Invalid file type: " + FileSuffix + "\n Only .txt files are allowed.");
      return;
   }

   let BegDate  = FileName.substring(22,30);
   let EndDate  = FileName.substring(33,41);
   let mm1 = BegDate.substring(0,2);
   let dd1 = BegDate.substring(3,5);
   let yy1 = BegDate.substring(6,8);
   let BegDate2 = "20"+yy1+"-"+mm1+"-"+dd1;
   mm1 = EndDate.substring(0,2);
   dd1 = EndDate.substring(3,5);
   yy1 = EndDate.substring(6,8);
   let EndDate2 = "20"+yy1+"-"+mm1+"-"+dd1;
   // alert ("X: " + file1 +  '\n' + FileName + '\n' + BegDate + '\n' + EndDate)
   // alert ("New: \n" + BegDate2 + '\n' + EndDate2 + "\n")
   // return;
   
    var sql1 = '';
    //let comma = '';
    let i = 1;   // skip over header line
    for (i = 1; i < lines.length; i++) { 
    //  alert('I: ' + i + ' ' + lines[i])
    //  html += `<li> ${lines[i]}`;
    // return;
      //if (i > 1) { comma = ','; }
      
      // Create the individual Insert Statements and save to local storage.
      const myArray = lines[i].split('\t');
      if (myArray[0] == '' || myArray[0] == 'EECode') {  // skip header and blank lines at end
         //alert('I: ' + i + ' ' + lines[i])
         }
      else {
        //  sql1 += `${comma}('${FileName}','${BegDate2}','${EndDate2}'`;
          sql1 += `('${FileName}','${BegDate2}','${EndDate2}'`;
      
         let ix = 0; 
         for (ix = 0; ix < 33; ix++) { 
              myArray[ix] = myArray[ix].replace(/\n/g, ""); // remove new line characters
              myArray[ix] = myArray[ix].replace(/\r/g, ""); // remove line feed characters
              sql1 +=  `,'${myArray[ix]}'`;
         };
         sql1 += `)\n`;

         html += `<tr><td>${i} <td>${myArray[0]}`;
         html += `<td> ${myArray[1]}`;
         html += `<td> ${myArray[2]}`;
         html += `<td> ${myArray[3]}`;
         html += `<td> ${myArray[4]}`;
         html += `<td> ${myArray[10]}`;
         html += `<td> ${myArray[11]}`;
         html += `<td> ${myArray[12]}`;
         html += `<td> ${myArray[13]}`;
         ctr1++;
        };
     };
    html += `</table>`;
    html += `<p>${ctr1} `;
 
    // Save the SQL statement to local storage
    localStorage.setItem("SQL1", sql1);
    console.log(sql1)

    document.getElementById("btnUpload1").style.display = 'block';

    document.getElementById("allItems").innerHTML = html;
    (document.getElementById("MSG1")  as HTMLInputElement).value = `Total of ${ctr1} records selected.  Click on "Save to MySQL" to upload to database.`; 

  };
  fileReader.readAsText(file);

}

private getUploadReport  = (): void => {
  
  fetch('https://ssi-node-api-001.azurewebsites.net/app002',{
   method: 'POST',
   body: JSON.stringify({ rpt: 32}),
   headers: {"Content-Type": "application/json"}
 })
 .then(function(response){
 
  if (response.ok) {
   //alert("Response")
   response.json().then((responseJSON) => {
       var ctr1 = 0;
       let html = `<table><tr><th colspan=2></th><th colspan=3><h3>List of Paycom Uploads</h3></th></tr>`;
       html += `<tr><th></th><th>File Name</th><th>Beg Date</th><th>End Date</th><th>Number of Records</th><th>Hours</th><th>Hours Earn</th><th>Is Diff</th><th>Diff Earn</th></tr>`;
      
       if (responseJSON.length == 0) { 
          alert("EMPTY");
          document.getElementById("allItems").innerHTML = "No Data Found.";
          return;
       }
 
       var i=0;
       for (i = 0; i < responseJSON.length; i++) { 
         html += `<tr>`;
         html += `<td><input type="checkbox" id="cbX${ctr1}"><input type="hidden" id="fnX${ctr1}" value='${responseJSON[i].filename}'></input></td>`;
         html += `<td> ${responseJSON[i].filename} </td>`;
         html += `<td> ${responseJSON[i].begdate} </td>`;
         html += `<td> ${responseJSON[i].enddate} </td>`;
         html += `<td style="text-align:right;"> ${responseJSON[i].nbr_of_records} </td>`;
         html += `<td style="text-align:right;"> ${responseJSON[i].hours} </td>`;
         html += `<td style="text-align:right;"> ${responseJSON[i].earn} </td>`;
         html += `<td style="text-align:right;"> ${responseJSON[i].diff} </td>`;
         html += `<td style="text-align:right;"> ${responseJSON[i].diffearn} </td>`;
         html += `</tr>`;
         ctr1++;
       };
 
     html += `<tr><td colSpan=4><br>Number of Uploads:  ${ctr1} </td></tr>`;
     html += `</td></tr></table><p><input type="hidden" id=CTR1 value='${ctr1}'>`;
 
     document.getElementById("allItems").innerHTML = html;
     console.log('LIST: \n' + html);
    // alert('HTML:' + html);
 
    (document.getElementById("btnUpload1")  as HTMLInputElement).style.display = 'none'; 
    (document.getElementById("btnUpload2")  as HTMLInputElement).style.display = 'none';   
    (document.getElementById("MSG1")  as HTMLInputElement).value = `"Choose File" and click on "Upload" to process.`; 
 
     console.log(responseJSON);
   });
  }
   else {
    alert(`Status code: ${response.status}` +  `${response.statusText}`);
  }
   return;
   //return response.json()
 
 }).then(function(body){
   console.log(body);
   //alert("BODY:" + body);
 });

}
 

 
private saveToMySQL  = async () => {

  // Get the SQL statement from local storage
  var sql1 = localStorage.getItem("SQL1")
  console.log("\n***\n")
  console.log(sql1)
  console.log("\n***") 
  // Process thru the array and split statements into groups of 100 as there is a size limitation on the API gateway
  var i=0;
  var ctr1=1;
  var sql_stmt = '';
  var comma = '';
  const myArray = sql1.split('\n');
  
  //alert ("LEN1:" + sql1.length + " LEN2:" + myArray.length)
 
  for (i = 0; i < myArray.length; i++) {
    //alert("I:" + i + "\n" + myArray[i] + ":\n")
    if (ctr1 == 1) { comma = ''; } else { comma = ','; }
    if (myArray[i] == '') { 
       // skip blank line at end of file
       // alert("BLANK" + i); 
       }
    else {
       sql_stmt += comma+myArray[i]+"\n";
    }
   
    
    if (ctr1 == 200) {  
       const resp = await this.insertRecords(sql_stmt);
       //alert("Insert:" + i)
       console.log("====================== \nSQL:\n" + resp + "\n")
       console.log(sql_stmt)
       sql_stmt = '';
       ctr1=0;
       }
    ctr1++
   }
   // Insert last Batch
   if (ctr1 != 0) {
    this.insertRecords(sql_stmt);
    console.log("====================== \nSQL:\n")
    console.log(sql_stmt)
   }

   (document.getElementById("btnUpload1") as HTMLInputElement).style.display = 'none';
   (document.getElementById("btnUpload2") as HTMLInputElement).style.display = 'block';
   (document.getElementById("readfile") as HTMLInputElement).value = '';
  }
 

private processDeletes = (): void => {
     //alert("DELETE:" + sql1)  
     var inCHK = (document.getElementById("MSG1")  as HTMLInputElement).value;
     if (inCHK != 'Click on "Delete" again to confirm') {
       (document.getElementById("MSG1")  as HTMLInputElement).value = 'Click on "Delete" again to confirm';
       return;
     }

     let ID001 = (document.getElementById("CTR1")  as HTMLInputElement).value;
     let CTRx = 0;
     CTRx = parseInt(ID001);
 
     let i = 0;
     let nbr_deleted = 0;
   
     do { 
        let ID   = (document.getElementById('fnX'+i)  as HTMLInputElement).value;
        let CHK0 = (document.getElementById('cbX'+i)  as HTMLInputElement).checked;
       // alert('CTRx: ' + i + '\n' + CHK0 + '\n' + ID);

        if (CHK0 == true) { 
           this.deleteRecords(ID);   
           nbr_deleted++;         
        }    
        i++;
       } 
       while (i < CTRx && i != 999);
 
       if (nbr_deleted != 0) {
          //this.showScreen('3');
          (document.getElementById("MSG1")  as HTMLInputElement).value = `Data was Deleted`;
       }
       else {
          (document.getElementById("MSG1")  as HTMLInputElement).value = `Nothing was selected to Delete.`;
       }
      
}
 

private deleteRecords  = (ID: any): void => {
  //alert("DELETE:" + ID)  
  fetch('https://ssi-node-api-001.azurewebsites.net/app002',{
    method: 'POST',
    body: JSON.stringify({ rpt: 35, in0: `${ID}`}),
    headers: {"Content-Type": "application/json"}
  })
  .then(function(response){
  
   if (response.ok) {
    //alert("Response")
    response.json().then((responseJSON) => {
      let html = '';
      if (responseJSON.length == 0) { 
         alert("EMPTY");
         document.getElementById("allItems").innerHTML = "No Data Found.";
         return;
      }

      document.getElementById("allItems").innerHTML = html;
     // alert('HTML:' + html);
     
      (document.getElementById("MSG1")  as HTMLInputElement).value = `Deletes were processed. Click on "Refresh" to show report.`; 
      (document.getElementById("btnUpload2") as HTMLInputElement).style.display = 'block';
      console.log('DELETE: \n' + ID);
  
  
      console.log(responseJSON);
    });
   }
    else {
     alert(`Status code: ${response.status}` +  `${response.statusText}`);
   }
    return;
    //return response.json()
  
  }).then(function(body){
    console.log(body);
   // alert("BODY:" + body);
  });
 
}

private insertRecords  = (sql1: any): void => {

 //alert("SAVE:" + sql1)
 console.log("\n***\n")
 console.log(sql1)
 console.log("\n***") 
 return;

 fetch('https://ssi-node-api-001.azurewebsites.net/app002',{
  method: 'POST',
  body: JSON.stringify({ rpt: 33, in0: `${sql1}`}),
  headers: {"Content-Type": "application/json"}
})
.then(function(response){

 if (response.ok) {
  //alert("Response")
  response.json().then((responseJSON) => {
      let html = '';
      if (responseJSON.length == 0) { 
         alert("EMPTY");
         document.getElementById("allItems").innerHTML = "No Data Found.";
         return;
      }

      var i=0;
      for (i = 0; i < responseJSON.length; i++) { 
        
      };

    document.getElementById("allItems").innerHTML = html;
   // alert('HTML:' + html);

   (document.getElementById("MSG1")  as HTMLInputElement).value = `Data Saved to Database.`; 

    console.log(responseJSON);
  });
 }
  else {
   alert(`Status code: ${response.status}` +  `${response.statusText}`);
 }
  return;
  //return response.json()

}).then(function(body){
  console.log(body);
//  alert("BODY:" + body);
});
}
*/

/*
// Get File to Upload
private getUploadFile2 = (): void => {

  let html = "<table>";
  html += `<tr><th>Row </th><th>Week </th><th>Name </th><th>Location </th><th>Agency </th><th>Department </th><th>Position </th><th>REG </th><th>OT1 </th><th>OT2</th><th>TOTAL </th><th>Rate</th><th>Markup</th><th>Full</th><th>REG </th><th>OT1 </th><th>OT2</th><th>TOTAL </th>`;
  let file = (document.getElementById("readfile2") as HTMLInputElement).files[0];
  const fileReader = new FileReader();
  fileReader.onload = event => {
    const fileText: any = event.target.result;
   // alert("FILE:" + fileText)
    const lines = fileText.split('\n');
   // const len1 = lines.length;
   // alert("line0:" + lines[0] + "LEN:" + len1 )

   var ctr1 = 0;
   let file1 = (document.getElementById("readfile2") as HTMLInputElement).value;
   let pos1 = file1.lastIndexOf("\\");
   //alert ("POS: " + pos1)
  
   var pos2 = file1.lastIndexOf(".");
   var FileSuffix = file1.substring(pos2+1,pos2+4);
   
   var FileName = file1.substring(pos1+1,pos2);
   //alert ("FILENAME:" + FileName + '\n' + FileSuffix);

   if (FileSuffix != "txt") {
      alert("Invalid file type: " + FileSuffix + "\n Only .txt files are allowed.");
      return;
   }

   var e = (document.getElementById("ddFYWK") as HTMLSelectElement);
   var inFYWK = e.options[e.selectedIndex].value;
   const myWeekParts = inFYWK.split('~');

   if (inFYWK == "") {
      alert("A valid Week must be selected. ");
      return;
   }

   let FYWK     = myWeekParts[0];
   let BegDate  = myWeekParts[1];
   let EndDate  = myWeekParts[2];
   FileName = 'Temporary Labor '+FYWK+' - '+BegDate+" - "+EndDate;
   // alert ("File Name: " + file1 +  '\n' + FileName + '\n' + BegDate + '\n' + EndDate)
   // alert ("New: \n" + BegDate2 + '\n' + EndDate2 + "\n")
   // return;
   
    var sql1 = '';
    //let comma = '';
    let i = 1;   // skip over header line
    for (i = 1; i < lines.length; i++) { 
    //  alert('I: ' + i + ' ' + lines[i])
    //  html += `<li> ${lines[i]}`;
    // return;
      //if (i > 1) { comma = ','; }
      
      // Create the individual Insert Statements and save to local storage.
      const myArray = lines[i].split('\t');
      if (myArray[0] == '' || myArray[0] == 'EECode') {  // skip header and blank lines at end
         //alert('I: ' + i + ' ' + lines[i])
         }
      else {
        //  sql1 += `${comma}('${FileName}','${BegDate2}','${EndDate2}'`;
          sql1 += `('${FileName}','${BegDate}','${EndDate}'`;
      
         let ix = 0; 
         for (ix = 0; ix < 25; ix++) { 
              myArray[ix] = myArray[ix].replace(/\n/g, ""); // remove new line characters
              myArray[ix] = myArray[ix].replace(/\r/g, ""); // remove line feed characters
              myArray[ix] = myArray[ix].replace(/\"/g, ""); // remove double-quotes

              // reformat numeric fields
              if (ix == 8 || ix == 9 || ix == 10 || ix == 11 || ix == 12 || ix == 13 || ix == 15 || ix == 20 || ix == 21 || ix == 22 || ix == 23 || ix == 24)
                 {
                  myArray[ix] = myArray[ix].replace(/ /g, "");  // remove all spaces 
                  myArray[ix] = myArray[ix].replace(/\$/g, "");  // remove all dollar signs 
                  myArray[ix] = myArray[ix].replace(/,/g, "");  // remove all commass 
                  myArray[ix] = myArray[ix].replace(/-/g, "");  // remove all dashes 
                  if (myArray[ix] == '') { myArray[ix] = 0; }   // default null to zero
                 }

              sql1 +=  `,'${myArray[ix]}'`;
         };
         sql1 += `)\n`;

         html += `<tr><td>${i} <td>${myArray[0]}`;
         html += `<td> ${myArray[1]}`;
         html += `<td> ${myArray[2]}`;
         html += `<td> ${myArray[3]}`;
         html += `<td> ${myArray[5]}`;
         html += `<td> ${myArray[14]}`;
         html += `<td> ${myArray[8]}`;
         html += `<td> ${myArray[9]}`;
         html += `<td> ${myArray[10]}`;
         html += `<td> ${myArray[13]}`;
         html += `<td> ${myArray[15]}`;
         html += `<td> ${myArray[16]}`;
         html += `<td> ${myArray[20]}`;
         html += `<td> ${myArray[21]}`;
         html += `<td> ${myArray[22]}`;
         html += `<td> ${myArray[23]}`;
         html += `<td> ${myArray[24]}`;
         ctr1++;
        };
     };
    html += `</table>`;
    html += `<p>${ctr1} `;
 
    // Save the SQL statement to local storage
    localStorage.setItem("SQL2", sql1);
    console.log(sql1)

    document.getElementById("btnUpload3").style.display = 'block';

    document.getElementById("allItems").innerHTML = html;
    (document.getElementById("MSG1")  as HTMLInputElement).value = `Total of ${ctr1} records selected.  Click on "Save to MySQL" to upload to database.`; 

  };
  fileReader.readAsText(file);

}

private getUploadReport2  = (): void => {
  
  fetch('https://ssi-node-api-001.azurewebsites.net/app002',{
   method: 'POST',
   body: JSON.stringify({ rpt: 38}),
   headers: {"Content-Type": "application/json"}
 })
 .then(function(response){
 
  if (response.ok) {
   //alert("Response")
   response.json().then((responseJSON) => {
       var ctr1 = 0;
       let html = `<table><tr><th colspan=2></th><th colspan=3><h3>List of Temporary Labor Uploads</h3></th></tr>`;
       html += `<tr><th></th><th>File Name</th><th>Beg Date</th><th>End Date</th><th>Number of Records</th><th>REG</th><th>OT1</th><th>OT2</th><th>TOTAL</th></tr>`;
      
       if (responseJSON.length == 0) { 
          alert("EMPTY");
          document.getElementById("allItems").innerHTML = "No Data Found.";
          return;
       }
 
       var i=0;
       for (i = 0; i < responseJSON.length; i++) { 
         html += `<tr>`;
         html += `<td><input type="checkbox" id="cbX${ctr1}"><input type="hidden" id="fnX${ctr1}" value='${responseJSON[i].filename}'></input></td>`;
         html += `<td> ${responseJSON[i].filename} </td>`;
         html += `<td> ${responseJSON[i].begdate} </td>`;
         html += `<td> ${responseJSON[i].enddate} </td>`;
         html += `<td style="text-align:right;"> ${responseJSON[i].nbr_of_records} </td>`;
         html += `<td style="text-align:right;"> ${responseJSON[i].REG} </td>`;
         html += `<td style="text-align:right;"> ${responseJSON[i].OT1} </td>`;
         html += `<td style="text-align:right;"> ${responseJSON[i].OT2} </td>`;
         html += `<td style="text-align:right;"> ${responseJSON[i].TOT1} </td>`;
         html += `</tr>`;
         ctr1++;
       };
 
     html += `<tr><td colSpan=4><br>Number of Uploads:  ${ctr1} </td></tr>`;
     html += `</td></tr></table><p><input type="hidden" id=CTR1 value='${ctr1}'>`;
 
     document.getElementById("allItems").innerHTML = html;
     console.log('LIST: \n' + html);
    // alert('HTML:' + html);
 
    (document.getElementById("btnUpload3")  as HTMLInputElement).style.display = 'none'; 
    (document.getElementById("btnUpload4")  as HTMLInputElement).style.display = 'none';   
    (document.getElementById("MSG1")  as HTMLInputElement).value = `"Choose File" and click on "Upload" to process.`; 
 
     console.log(responseJSON);
   });
  }
   else {
    alert(`Status code: ${response.status}` +  `${response.statusText}`);
  }
   return;
   //return response.json()
 
 }).then(function(body){
   console.log(body);
  // alert("BODY:" + body);
 });

}
 

 
private saveToMySQL2  = async () => {

  // Get the SQL statement from local storage
  var sql1 = localStorage.getItem("SQL2")
   
  // Process thru the array and split statements into groups of 100 as there is a size limitation on the API gateway
  var i=0;
  var ctr1=1;
  var sql_stmt = '';
  var comma = '';
  const myArray = sql1.split('\n');
  
  //alert ("LEN1:" + sql1.length + " LEN2:" + myArray.length)
 
  for (i = 0; i < myArray.length; i++) {
    //alert("I:" + i + "\n" + myArray[i] + ":\n")
    if (ctr1 == 1) { comma = ''; } else { comma = ','; }
    if (myArray[i] == '') { 
       // skip blank line at end of file
       // alert("BLANK" + i); 
       }
    else {
       sql_stmt += comma+myArray[i]+"\n";
    }
   
    
    if (ctr1 == 200) {  
       const resp = await this.insertRecords2(sql_stmt);
       //alert("Insert:" + i)
       console.log("====================== \nSQL:\n" + resp + "\n")
       console.log(sql_stmt)
       sql_stmt = '';
       ctr1=0;
       }
    ctr1++
   }
   // Insert last Batch
   if (ctr1 != 0) {
    this.insertRecords2(sql_stmt);
    console.log("====================== \nSQL:\n")
    console.log(sql_stmt)
   }

   (document.getElementById("btnUpload3") as HTMLInputElement).style.display = 'none';
   (document.getElementById("btnUpload4") as HTMLInputElement).style.display = 'block';
   (document.getElementById("readfile2") as HTMLInputElement).value = '';
  }
 

private processDeletes2 = (): void => {
     //alert("DELETE:" + sql1)  
     var inCHK = (document.getElementById("MSG1")  as HTMLInputElement).value;
     if (inCHK != 'Click on "Delete" again to confirm') {
       (document.getElementById("MSG1")  as HTMLInputElement).value = 'Click on "Delete" again to confirm';
       return;
     }

     let ID001 = (document.getElementById("CTR1")  as HTMLInputElement).value;
     let CTRx = 0;
     CTRx = parseInt(ID001);
 
     let i = 0;
     let nbr_deleted = 0;
   
     do { 
        let ID   = (document.getElementById('fnX'+i)  as HTMLInputElement).value;
        let CHK0 = (document.getElementById('cbX'+i)  as HTMLInputElement).checked;
       // alert('CTRx: ' + i + '\n' + CHK0 + '\n' + ID);

        if (CHK0 == true) { 
           this.deleteRecords2(ID);   
           nbr_deleted++;         
        }    
        i++;
       } 
       while (i < CTRx && i != 999);
 
       if (nbr_deleted != 0) {
          (document.getElementById("MSG1")  as HTMLInputElement).value = `Data was Deleted`;
       }
       else {
          (document.getElementById("MSG1")  as HTMLInputElement).value = `Nothing was selected to Delete.`;
       }
      
}
 

private deleteRecords2  = (ID: any): void => {
  //alert("DELETE:" + ID)  
  fetch('https://ssi-node-api-001.azurewebsites.net/app002',{
    method: 'POST',
    body: JSON.stringify({ rpt: 40, in0: `${ID}`}),
    headers: {"Content-Type": "application/json"}
  })
  .then(function(response){
  
   if (response.ok) {
    //alert("Response")
    response.json().then((responseJSON) => {
      let html = '';
      if (responseJSON.length == 0) { 
         alert("EMPTY");
         document.getElementById("allItems").innerHTML = "No Data Found.";
         return;
      }

      document.getElementById("allItems").innerHTML = html;
     // alert('HTML:' + html);
     
      (document.getElementById("MSG1")  as HTMLInputElement).value = `Deletes were processed. Click on "Refresh" to show report.`; 
      (document.getElementById("btnUpload4") as HTMLInputElement).style.display = 'block';
      console.log('DELETE: \n' + ID);
  
  
      console.log(responseJSON);
    });
   }
    else {
     alert(`Status code: ${response.status}` +  `${response.statusText}`);
   }
    return;
    //return response.json()
  
  }).then(function(body){
    console.log(body);
   // alert("BODY:" + body);
  });
 
}

private insertRecords2  = (sql1: any): void => {

 //alert("SAVE:" + sql1)
 //return;

 fetch('https://ssi-node-api-001.azurewebsites.net/app002',{
  method: 'POST',
  body: JSON.stringify({ rpt: 39, in0: `${sql1}`}),
  headers: {"Content-Type": "application/json"}
})
.then(function(response){

 if (response.ok) {
  //alert("Response")
  response.json().then((responseJSON) => {
      let html = '';
      if (responseJSON.length == 0) { 
         alert("EMPTY");
         document.getElementById("allItems").innerHTML = "No Data Found.";
         return;
      }

      var i=0;
      for (i = 0; i < responseJSON.length; i++) { 
        
      };

    document.getElementById("allItems").innerHTML = html;
   // alert('HTML:' + html);

   (document.getElementById("MSG1")  as HTMLInputElement).value = `Data Saved to Database.`; 

    console.log(responseJSON);
  });
 }
  else {
   alert(`Status code: ${response.status}` +  `${response.statusText}`);
 }
  return;
  //return response.json()

}).then(function(body){
  console.log(body);
 // alert("BODY:" + body);
});
}
*/

private getDropDown  = (): void => {
  
  fetch('https://ssi-node-api-001.azurewebsites.net/app002',{
   method: 'POST',
   body: JSON.stringify({ rpt: 41}),
   headers: {"Content-Type": "application/json"}
 })
 .then(function(response){
 
  if (response.ok) {
   //alert("Response")
   response.json().then((responseJSON) => {
       let html = ``;
 
       var i=0;
       for (i = 0; i < responseJSON.length; i++) { 
         var wk_label = `${responseJSON[i].FYWK_LABEL}`;
         var wk_key = `${responseJSON[i].FYWK_LABEL}`+"~"+`${responseJSON[i].BEG_DATE}`+"~"+`${responseJSON[i].END_DATE}`;
         html += `<option value="${wk_key}"> ${wk_label}`;
       };
       
       html += `<option value=''> `;
 
     document.getElementById("ddFYWK").innerHTML = html;
     console.log('DD-WK: \n' + html);
    // alert('HTML:' + html); 
     console.log(responseJSON);
   });
  }
   else {
    alert(`Status code: ${response.status}` +  `${response.statusText}`);
  }
   return;
   //return response.json()
 
 }).then(function(body){
   console.log(body);
  // alert("BODY:" + body);
 });

}

/*  
  // Process Changes
  private processNew = (): void => {

   //return;

    let ID001 = (document.getElementById("CTR1")  as HTMLInputElement).value;
    let CTRx = 0;
    CTRx = parseInt(ID001);

    let i = 0;
  
    do { 
       // bob
       //  let ID   = (document.getElementById('ID'+i)  as HTMLInputElement).value;
       //  alert("CREATE:" + ID)
         this.createItem(i);            
      
      i++;
      } 
      while (i < CTRx && i != 999);

      (document.getElementById("MSG1")  as HTMLInputElement).value = `Data was Saved`;
};
*/


/*
 // COPY
  private insertNew = (): void => {

    this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report Master List')/items?&$orderBy=ID&$top=999`,
  //  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('ZAP_FISCAL_CALENDAR')/items?$top=999`, $filter=SplitBy eq 'CHAIN'
   
    SPHttpClient.configurations.v1,
    {
      headers: {
        'Accept': 'application/json;odata=nometadata',
        'odata-version': ''
      }
    })
    .then((response: SPHttpClientResponse) => {
      if (response.ok) {
        response.json().then((responseJSON) => {
          let ctr1 = 0;
          let html = ` <table className={styles.tb1}><tr><th colspan=2>List of Available Reports</th></tr><tr>`;

          responseJSON.value.map((item: any, index: any) => {
      
            html += `<tr><td><input type="checkbox" id="cbX${item.ID}"></td><td>${item.Title}`;
            html += `<input type="hidden" id="cbO${item.ID}" value="false">`;
            html += `<input type="hidden" id="IDO${item.ID}" value="">`;
            html += `<input type="text" id="ID${ctr1}" value="${item.ID}">`;
            html += `<input type="text" id="Title${item.ID}" value="${item.Title}">`;
            html += `<input type="text" id="ReportType${item.ID}" value="${item.ReportType}">`;
            html += `<input type="text" id="Department${item.ID}" value="${item.Department}">`;
            html += `<tr><td><input type="text" id="ReportID${item.ID}" value="${item.ReportID}">`;
            html += `<input type="text" id="JobName${item.ID}" value="${item.JobName}">`;
            html += `<input type="text" id="URL1${item.ID}" value="${item.URL}">`;
            html += `<input type="text" id="SplitBy${item.ID}" value="${item.SplitBy}">`;
            html += `<input type="text" id="Active${item.ID}" value="${item.Active}">`;
            ctr1++;
           
          });
          html += `</table><p><input type="text" id=CTR1 value='${ctr1}'>`;
          document.getElementById("allItems").innerHTML = html;
          alert('HTML:' + html);
          console.log(responseJSON);
     
          let MSGOK = (document.getElementById("MSG1")  as HTMLInputElement).value;
          if (MSGOK != 'Data was Saved') { 
            (document.getElementById("MSG1")  as HTMLInputElement).value = `Select/Unselect Reports and Click on 'Save' to process.`;
          }
        }).then(() => this.processNew());;
      } else {
        response.json().then((responseJSON) => {
          console.log(responseJSON);
          alert(`Something went wrong! Check the error in the browser console.`);
        });
      }
    }).catch(error => {
      console.log(error);
    });
  }
 */

  /*
  // Create Item
  private createNew = (i: any): void => {

    let ID   = (document.getElementById('ID'+i)  as HTMLInputElement).value;
 
 //   let ID1 = (document.getElementById('ID'+i)  as HTMLInputElement).value;
 //   let ID2 = (document.getElementById('REPORT'+ID)  as HTMLInputElement).value;
 //   let ID3 = (document.getElementById('SystemID'+ID)  as HTMLInputElement).value;
 //   let ID4 = (document.getElementById('ReportType'+ID)  as HTMLInputElement).value;
 //   alert('Create: ' + ID + '\n' + ID1 + '\n' + ID2 + '\n' + ID3 + '\n' + ID4);
 
     const body: string = JSON.stringify({
       'Title': (document.getElementById('REPORT'+ID)  as HTMLInputElement).value,
       'ReportType': (document.getElementById('ReportType'+ID)  as HTMLInputElement).value,
       'Department': (document.getElementById('SystemID'+ID)  as HTMLInputElement).value,
       'ReportID': (document.getElementById('ReportID'+ID)  as HTMLInputElement).value,  
       'JobName': (document.getElementById('JobName'+ID)  as HTMLInputElement).value, 
       'URL': (document.getElementById('URL1'+ID)  as HTMLInputElement).value, 
       'SplitBy': (document.getElementById('SplitBy'+ID)  as HTMLInputElement).value

     });
     this.props.context.spHttpClient.post(`${this.props.context.pageContext.web.absoluteUrl}/_api/web/lists/getbytitle('temp Report Master List')/items`,
       SPHttpClient.configurations.v1, {
       headers: {
         'Accept': 'application/json;odata=nometadata',
         'Content-type': 'application/json;odata=nometadata',
         'odata-version': ''
       },
       body: body
     })
       .then((response: SPHttpClientResponse) => {
         if (response.ok) {
           response.json().then((responseJSON) => {
             console.log(responseJSON);
            // alert(`Item created successfully with ID: ${responseJSON.ID}`);
             (document.getElementById("MSG1")  as HTMLInputElement).value = `Data was Saved`;
           });
         } else {
           response.json().then((responseJSON) => {
             console.log(responseJSON);
             alert(`Create: Something went wrong! Check the error in the browser console.`);
           });
         }
       }).catch(error => {
         console.log(error);
       });
    
  }
 */
}

